{{
}}
'  JAVACODESIZE = $1600 ' debug only
'  JAVACODESIZE = $4000  '$3800 to $4A00 without debugger
  JAVACODESIZE = 20000 ' this is with no bytecode for pasm runner
'  JAVACODESIZE = 18000 ' space for spin runner

  NATIVE_BIT = $100
  EXCPTN_BIT = $8000
  MALLOC_BIT = $10000
  
obj
  def: "pjdef"
  pcn: "pjcon"
  pjd: "pjdata"
  pn : "pnative"

pub start(cdp)
  start1(cdp,pjd.getTablePtr(0)) ' start jvm
  start2(cdp,pjd.getTablePtr(1)) ' start jvm
  start3(cdp,pjd.getTablePtr(2)) ' start jvm

pub start1(cmdptr,tptr)
  long[tptr] := @JemJmp   
  cognew(@jvm1, cmdptr)
  waitcnt(clkfreq/10+cnt)

pub start2(cmdptr,tptr)
  long[tptr] := @JemJmp2   
  cognew(@jvm2, cmdptr)
  waitcnt(clkfreq/10+cnt)

pub start3(cmdptr,tptr)
  long[tptr] := @JemJmp3  
  cognew(@jvm3, cmdptr)
  waitcnt(clkfreq/10+cnt)


pub getJemJmp1
  return @jemjmp

pub getJemJmp2
  return @jemjmp2

pub getJemJmp3
  return @jemjmp3


pub getjvm1
  return @jvm1
  
pub getjvm2
  return @jvm2

pub getjvm3
  return @jvm3
  
  
pub getJavaCodeSize
  return JAVACODESIZE
  
pub getProgBuffer
  return @progbuf

pub getProgPtr
  return @jemcode

pub getProgSize
  return @jemcode_end-@jemcode '@jemcode_end-@jemcode


dat
JemJmp  ' bytecodes handled in this COG
        word  doJem_NOP               ' $00     0 
        word  doJem_ICONST_M1         ' $01     2
        word  doJem_ICONST_0          ' $02     2
        word  doJem_ICONST_1          ' $03     2
        word  doJem_ICONST_2          ' $04     2
        word  doJem_ICONST_3          ' $05     2
        word  doJem_ICONST_4          ' $06     2
        word  doJem_ICONST_5          ' $07     2
        word  doJem_BIPUSH            ' $08     4
        word  doJem_SIPUSH            ' $09     2
        word  doJem_ILOAD             ' $0A     7
        word  doJem_ILOAD_0           ' $0B     2
        word  doJem_ILOAD_1           ' $0C     2
        word  doJem_ILOAD_2           ' $0D     2
        word  doJem_ILOAD_3           ' $0E     2
        word  doJem_ISTORE            ' $0F     9
        word  doJem_ISTORE_0          ' $10     2
        word  doJem_ISTORE_1          ' $11     2
        word  doJem_ISTORE_2          ' $12     2
        word  doJem_ISTORE_3          ' $13     2
        word  doJem_IFEQ              ' $14     4
        word  doJem_IFNE              ' $15     4
        word  doJem_IFLT              ' $16     4
        word  doJem_IFLE              ' $17     4
        word  doJem_IFGT              ' $18     4
        word  doJem_IFGE              ' $19     4
        word  doJem_IF_ICMPEQ         ' $1A     4
        word  doJem_IF_ICMPNE         ' $1B     4
        word  doJem_IF_ICMPLT         ' $1C     4
        word  doJem_IF_ICMPGE         ' $1D     4
        word  doJem_IF_ICMPGT         ' $1E     4
        word  doJem_IF_ICMPLE         ' $1F     4
        word  doJem_IF_ACMPEQ         ' $20     1
        word  doJem_IF_ACMPNE         ' $21     1
        word  doJem_IRETURN           ' $22     5
        word  doJem_RETURN            ' $23     >20
        word  doJem_INVOKEVIRTUAL     ' $24     >20
        word  doJem_INVOKESTATIC      ' $25     >20
        word  doJem_GETSTATIC         ' $26     4
        word  doJem_PUTSTATIC         ' $27     7

JemJmp2 ' bytecodes handled in COG 2
        word  doJem_POP               ' $28     2
        word  doJem_POP2              ' $29     6
        word  doJem_DUP               ' $2A     3
        word  doJem_DUP_X1            ' $2B     3
        word  doJem_DUP_X2            ' $2C     5
        word  doJem_DUP2              ' $2D     3
        word  doJem_DUP2_X1           ' $2E     6
        word  doJem_DUP2_X2           ' $2F     5
        word  doJem_SWAP              ' $30     3
        word  doJem_IADD              ' $31     6
        word  doJem_ISUB              ' $32     6
        word  doJem_INEG              ' $33     4
        word  jvm2done                ' $34     
        word  doJem_IOR               ' $35     3
        word  jvm2done                ' $36
        word  doJem_ISHL              ' $37     3
        word  jvm2done                ' $38
        word  doJem_ISHR              ' $39     3
        word  jvm2done                ' $3A
        word  doJem_IUSHR             ' $3B     3
        word  jvm2done                ' $3C
        word  doJem_IAND              ' $3D     3
        word  jvm2done                ' $3E
        word  doJem_IXOR              ' $3F     3
        word  jvm2done                ' $40
        word  doJem_I2B               ' $41     3
        word  jvm2done                ' $42
        word  doJem_GOTO              ' $43     3
        word  jvm2done                ' $44
        word  doJem_INVOKEINTERFACE   ' $45     1
        word  jvm2done                ' $46
        word  doJem_ARRAYLENGTH       ' $47     12
        word  jvm2done                ' $48
        word  doJem_ATHROW            ' $49
        word  jvm2done                ' $4A
        word  doJem_CHECKCAST         ' $4B
        word  jvm2done                ' $4C
        word  doJem_INSTANCEOF        ' $4D
        word  jvm2done                ' $4E
        word  doJem_WIDE              ' $4F
        word  jvm2done                ' $50
        word  doJem_IINC              ' $51
        word  jvm2done                ' $52
        word  doJem_GETFIELD          ' $53
        word  jvm2done                ' $54
        word  doJem_PUTFIELD          ' $55
        word  jvm2done                ' $56
        word  doJem_NEW               ' $57
        word  jvm2done                ' $58

JemJmp3 ' bytecodes handled in COG 3
        word  doJem_NEWARRAY          ' $59
        word  jvm3done                ' $5A
        word  doJem_ANEWARRAY         ' $5B
        word  jvm3done                ' $5C
        word  doJem_IALOAD            ' $5D
        word  jvm3done                ' $5E
        word  doJem_IASTORE           ' $5F
        word  jvm3done                ' $60
        word  doJem_BALOAD            ' $61
        word  jvm3done                ' $62
        word  doJem_BASTORE           ' $63
        word  jvm3done                ' $64
        word  doJem_LDC               ' $65
        word  jvm3done                ' $66
        word  doJem_LDC_W             ' $67
        word  jvm3done                ' $68
        word  jvm3done                ' $69 'doJem_LDC2_W  not used
        word  jvm3done                ' $6A
        word  doJem_IMUL              ' $6B
        word  jvm3done                ' $6C
        word  doJem_IDIV              ' $6D
        word  jvm3done                ' $6E
        word  doJem_IREM              ' $6F
        word  jvm3done                ' $70
        word  doJem_JSR               ' $71
        word  jvm3done                ' $72
        word  doJem_RET               ' $73
        word  jvm3done                ' $74
        word  doJem_TABLESWITCH       ' $75
        word  jvm3done                ' $76
        word  doJem_LOOKUPSWITCH      ' $77

{
con     ' native method defines ... not necessary ?

        ndef_writeJvmReg          = 0
        ndef_readJvmReg           = 1
        ndef_writeObject          = 2
        ndef_coreCpuDelay         = 3
        ndef_commMessage          = 4
        ndef_page5                = 5
        ndef_coreCpuCount         = 6
        ndef_coreCpuRcTime        = 7
        ndef_coreCpuPulseIn       = 8
        ndef_coreCpuPulseOut      = 9
        ndef_coreCpuReadPin       = 10
        ndef_coreCpuWritePin      = 11
        ndef_coreCpuShifIn        = 12
        ndef_coreCpuShiftOut      = 13
        ndef_isCarry              = 14
        ndef_page15               = 15
        ndef_coreCpuUninstall     = 16
        ndef_coreCpuInstall       = 17
        ndef_coreCpuNap           = 18
        ndef_coreCpuSetOutput     = 19
        ndef_page20               = 20
        ndef_coreCpuSetInput      = 21
        ndef_page22               = 22
        ndef_coreCpuReadSRAM      = 23
        ndef_page24               = 24
        ndef_coreWriteSRAM        = 25        
        ndef_page26               = 26
        ndef_coreEepromRead       = 27
        ndef_page28               = 28
        ndef_coreEepromWrite      = 29
        ndef_page30               = 30
        ndef_coreUartTxInit       = 31
        ndef_coreUartRxInit       = 32
        ndef_coreUartRxRead       = 33
        ndef_callBackReturnTwo    = 34
        ndef_coreTimerInit        = 35
        ndef_coreTimerLatch       = 36
        ndef_page37               = 37
        ndef_corePwmInstall       = 38
        ndef_page39               = 39
        ndef_corePwmUpdate        = 40
        ndef_page41               = 41
        ndef_coreDacInstall       = 42
        ndef_page43               = 43
        ndef_coreAdcInstall       = 44
        ndef_page45               = 45
        ndef_comGetByte           = 46
        ndef_page47               = 47
         
dat

'   Execute a native function. Arguments for native functions are either in VP registers
'   or on the stack. If a native function returns a value it must be placed on top of the stack.

NvmJmp  ' native command jump table
        word   nvm_writeJvmReg          ' 0
        word   nvm_readJvmReg           ' 1
        word   nvm_writeObject          ' 2
        word   nvm_coreCpuDelay         ' 3
        word   nvm_commMessage          ' 4
        word   nvm_page                 ' 5
        word   nvm_coreCpuCount         ' 6
        word   nvm_coreCpuRcTime        ' 7
        word   nvm_coreCpuPulseIn       ' 8
        word   nvm_coreCpuPulseOut      ' 9
        word   nvm_coreCpuReadPin       ' 10
        word   nvm_coreCpuWritePin      ' 11
        word   nvm_coreCpuShifIn        ' 12
        word   nvm_coreCpuShiftOut      ' 13
        word   nvm_isCarry              ' 14
        word   nvm_page                 ' 15
        word   nvm_coreCpuUninstall     ' 16
        word   nvm_coreCpuInstall       ' 17
        word   nvm_coreCpuNap           ' 18
        word   nvm_coreCpuSetOutput     ' 19
        word   nvm_page                 ' 20
        word   nvm_coreCpuSetInput      ' 21
        word   nvm_page                 ' 22
        word   nvm_coreCpuReadSRAM      ' 23
        word   nvm_page                 ' 24
        word   nvm_coreWriteSRAM        ' 25        
        word   nvm_page                 ' 26
        word   nvm_coreEepromRead       ' 27
        word   nvm_page                 ' 28
        word   nvm_coreEepromWrite      ' 29
        word   nvm_page                 ' 30
        word   nvm_coreUartTxInit       ' 31
        word   nvm_coreUartRxInit       ' 32
        word   nvm_coreUartRxRead       ' 33
        word   nvm_callBackReturnTwo    ' 34
        word   nvm_coreTimerInit        ' 35
        word   nvm_coreTimerLatch       ' 36
        word   nvm_page                 ' 37
        word   nvm_corePwmInstall       ' 38
        word   nvm_page                 ' 39
        word   nvm_corePwmUpdate        ' 40
        word   nvm_page                 ' 41
        word   nvm_coreDacInstall       ' 42
        word   nvm_page                 ' 43
        word   nvm_coreAdcInstall       ' 44
        word   nvm_page                 ' 45
        word   nvm_comGetByte           ' 46
        word   nvm_page                 ' 47                
}

  
dat     ' java program loads here after jvm startup

  dummy   long  0 [1]   ' used to put progbuf on progbuf MOD $10 = 0
  progbuf long $53535353


dat     '' pasm implementing jvm 
jvm1           org
  long 0 [8]  ' for debugger

'_____________________________________________________________________________
' parameter setup
'
setup
  mov         tp,  par
  mov         t1,  #cmdp
  mov         t0,  #pcn#JVM_ENG_NOOFPARMS         ' noof parameters
ploop
  movd        pwrite,t1
  add         t1,    #1
pwrite  mov   0-0, tp
  add         tp, #4
  djnz        t0,  #ploop

jvmloop
  rdlong       rc,  ctrp wz     ' get java bytecode command
  if_z  jmp    #jvmloop         ' if no command loop
  rdlong       jem, jemp        ' get jem offset

  rdlong       rc,  cmdp
  cmp          rc,  #0 wz,wc    ' 0 is a valid opcode
  if_b  jmp    #jvmloop
  cmp          rc,  #pcn#Jem_PUTSTATIC wz,wc
  if_a  jmp    #jvmloop
  
  rdlong       tp,  tap1        ' get table base address
  shl          rc,  #1
  add          tp,  rc          ' get tap[rc] address
  rdword       t0,  tp          ' get tap[rc] value                                                                                                 
  movs         callit,t0        ' set routine address
  nop  
callit  jmp    #0-0             ' jmp bytecode routine

jvmDone
  mov          rc, #0
  wrlong       rc, ctrp       
  jmp          #jvmloop


'_____________________________________________________________________________
''  doJem_NOP Meaning: Do nothing except Increment PC.
doJem_NOP
  jmp          #incrPCdone

'_____________________________________________________________________________
'
doJem_ICONST_M1
''  doJem_ICONST_M1 Meaning: Push the integer constant -1.
  mov          rc, MINUS1
  jmp          #pushIncrPCdone

'_____________________________________________________________________________
'
doJem_ICONST_0
''  doJem_ICONST_0 Meaning: Push the integer constant 0.
  mov          rc, #0
  jmp          #pushIncrPCdone

'_____________________________________________________________________________
'
doJem_ICONST_1
''  doJem_ICONST_1 Meaning: Push the integer constant 1.
  mov          rc, #1
  jmp          #pushIncrPCdone

'_____________________________________________________________________________
'
doJem_ICONST_2
''  doJem_ICONST_2 Meaning: Push the integer constant 2.
  mov          rc, #2
  jmp          #pushIncrPCdone

'_____________________________________________________________________________
'
doJem_ICONST_3
''  doJem_ICONST_3 Meaning: Push the integer constant 3.
  mov          rc, #3
  jmp          #pushIncrPCdone

'_____________________________________________________________________________
'
doJem_ICONST_4
''  doJem_ICONST_4 Meaning: Push the integer constant 4.
  mov          rc, #4
  jmp          #pushIncrPCdone

'_____________________________________________________________________________
'
doJem_ICONST_5
''  doJem_ICONST_5 Meaning: Push the integer constant 5.
  mov          rc, #5
  jmp          #pushIncrPCdone

'_____________________________________________________________________________
'
doJem_BIPUSH
''  doJem_BIPUSH Meaning: Push a 1-byte signed integer.
{
  JEM format: bipush,byte1
  byte1 is a signed 1byte constant: if byte1 < 128 const = byte1 else const = byte1 | $FF00 
  val := jd.readJavaByte(jd.getJvmPC+1)
  val := jc.b2i(val)
  js.push(val)
  jd.incJvmPC(2)
}
'  val := jd.readJavaByte(jd.getJvmPC+1)
  call         #loadBytePcPlus1 ' could do move rc, pc; add rc, #1; call #loadByte
'  val := jc.b2i(val)
  test         rc, #$80 wz
  if_nz or     rc, M1BXT  ' byte extend
'  js.push(val)
'  jd.incJvmPC(2)
  jmp          #pushIncrPC2done

'_____________________________________________________________________________
'
doJem_SIPUSH
''  doJem_SIPUSH Meaning: Push a 2-byte signed integer.
{
  JEM format: sipush,byte1,byte2
  byte1 and byte2 form 16bits constant: const = (byte1<<8)|(byte2) 
  val := jd.readJavaIntBE(jd.getJvmPC+1)
  js.push(val)
  jd.incJvmPC(3)
}
  call         #loadWordPcPlus1 ' could do move rc, pc; add rc, #1; call #loadWord
  jmp          #pushIncrPC3done

'_____________________________________________________________________________
'
doJem_ILOAD
''  doJem_ILOAD Meaning: Load integer from local variable.
{
  JEM format: iload,byte1
  byte1 is the index of the local variable.
  index := jd.readJavaByte(jd.getJvmPC+1)
  fp := jd.getJvmFP
  val := jd.readJavaIntBE(fp + (index<<1))
  js.push(val)
  jd.incJvmPC(2)
}
  call         #loadBytePcPlus1
  mov          t0, rc   ' save index
  shl          t0, #1
  rdlong       rc, fp
  add          rc, t0
  call         #loadWord
  jmp          #pushIncrPC2done

'_____________________________________________________________________________
'
doJem_ILOAD_0
''  doJem_ILOAD_0 Meaning: Load integer from local variable with index 0.
{
  JEM format: iload_0
  fp := jd.getJvmFP
  val := jd.readJavaIntBE(fp)
  js.push(val)
  jd.incJvmPC(1)
}
  mov         parm,#0
  jmp         #iload_n

'_____________________________________________________________________________
'
doJem_ILOAD_1
''  doJem_ILOAD_1 Meaning: Load integer from local variable with index 1.
{
  JEM format: iload_1
  fp := jd.getJvmFP
  val := jd.readJavaIntBE(fp + 2)
  js.push(val)
  jd.incJvmPC(1)
}
  mov         parm,#2
  jmp         #iload_n

'_____________________________________________________________________________
'
doJem_ILOAD_2
''  doJem_ILOAD_2 Meaning: Load integer from local variable with index 2.
{
  JEM format: iload_2
  fp := jd.getJvmFP
  val := jd.readJavaIntBE(fp + 4)
  js.push(val)
  jd.incJvmPC(1)
}
  mov         parm,#4
  jmp         #iload_n

'_____________________________________________________________________________
'
doJem_ILOAD_3
''  doJem_ILOAD_3 Meaning: Load integer from local variable with index 3.

{
  JEM format: iload_3
  fp := jd.getJvmFP
  val := jd.readJavaIntBE(fp + 6)
  js.push(val)
  jd.incJvmPC(1)
}
  mov         parm,#6
  jmp         #iload_n

iload_n
  rdlong       rc,  fp
  add          rc,  parm
  call         #loadWord
  jmp          #pushIncrPCdone

'_____________________________________________________________________________
'
doJem_ISTORE
''  doJem_ISTORE Meaning: Store integer into local variable.
{
  JEM format: istore,byte1
  byte1 is the index of the local variable.
  index := jd.readJavaByte(jd.getJvmPC+1)
  fp := jd.getJvmFP
  val := js.pop
  jd.writeJavaIntBE(fp + (index<<1),val)
  jd.incJvmPC(2)
}
  call         #loadBytePcPlus1
  mov          t0,  rc      ' save index
  shl          t0,  #1
  rdlong       rc,  fp
  add          rc,  t0
  mov          arg1,rc      ' saveWord address
  call         #jpop
  call         #saveWord
  jmp          #incrPC2done

'_____________________________________________________________________________
'
doJem_ISTORE_0
''  doJem_ISTORE_0 Meaning: Store integer into local variable with index 0.
{
  JEM format: istore_0
  val := js.pop
  fp := jd.getJvmFP
  jd.writeJavaIntBE(fp,val)
  jd.incJvmPC(1)
}
  mov         parm, #0
  jmp         #istore_n

'_____________________________________________________________________________
'
doJem_ISTORE_1
''  doJem_ISTORE_1 Meaning: Store integer into local variable with index 1.
{
  JEM format: istore_1
  val := js.pop
  fp := jd.getJvmFP
  jd.writeJavaIntBE(fp + 2,val)
  jd.incJvmPC(1)
}
  mov         parm, #2
  jmp         #istore_n

'_____________________________________________________________________________
'
doJem_ISTORE_2
''  doJem_ISTORE_2 Meaning: Store integer into local variable with index 2.
{
  JEM format: istore_2
  val := js.pop
  fp := jd.getJvmFP
  jd.writeJavaIntBE(fp + 4,val)
  jd.incJvmPC(1)
}
  mov         parm, #4
  jmp         #istore_n

'_____________________________________________________________________________
'
doJem_ISTORE_3
''  doJem_ISTORE_3 Meaning: Store integer into local variable with index 3.
{
  JEM format: istore_3
  val := js.pop
  fp := jd.getJvmFP
  jd.writeJavaIntBE(fp + 6,val)
  jd.incJvmPC(1)
}
  mov         parm, #6
  jmp         #istore_n

istore_n
  call         #jpop
  rdlong       arg1,fp
  add          arg1,parm
  call         #saveWord
  jmp          #incrPCdone

'_____________________________________________________________________________
'
doJem_IFEQ
''  doJem_IFEQ Meaning: Branch if equal to 0.
{
  JEM format: ifeq,byte1,byte2
  byte1 and byte2 form 16bits offset to add to pc: offset = (byte1<<8)|(byte2) 
  w1 := js.pop
  w1 := ~~w1 'sign extend b15
  offset := jd.readJavaIntBE(jd.getJvmPC+1)
  if w1 == 0
    jd.incJvmPC(offset)
  else
    jd.incJvmPC(3)
}
  call         #loadCmpzWord
  if_z         jmp #:doit       ' if w1 == 0, do jump
  jmp          #incrPC3done
:doit  jmp     #addWordPCdone

'_____________________________________________________________________________
'
doJem_IFNE
''  doJem_IFNE Meaning: Branch if not equal to 0.
{
  JEM format: ifne,byte1,byte2
  byte1 and byte2 form 16bits offset to add to pc: offset = (byte1<<8)|(byte2) 
  w1 := js.pop
  w1 := ~~w1 'sign extend b15
  offset := jd.readJavaIntBE(jd.getJvmPC+1)
  if w1 <> 0
    jd.incJvmPC(offset)
  else
    jd.incJvmPC(3)
}
  call         #loadCmpzWord
  if_nz        jmp #:doit       ' if w1 <> 0, do jump
  jmp          #incrPC3done
:doit  jmp     #addWordPCdone

'_____________________________________________________________________________
'
doJem_IFLT
''  doJem_IFLT Meaning: Branch if less than 0.
{
  JEM format: iflt,byte1,byte2
  byte1 and byte2 form 16bits offset to add to pc: offset = (byte1<<8)|(byte2) 
  w1 := js.pop
  w1 := ~~w1 'sign extend b15
  offset := jd.readJavaIntBE(jd.getJvmPC+1)
  if w1 < 0
    jd.incJvmPC(offset)
  else
    jd.incJvmPC(3)
}
  call         #loadCmpzWord
  if_b         jmp #:doit       ' if w1 < 0, do jump
  jmp          #incrPC3done
:doit  jmp     #addWordPCdone

'_____________________________________________________________________________
'
doJem_IFLE
''  doJem_IFLE Meaning: Branch if less than or equal to 0.
{
  JEM format: ifle,byte1,byte2
  byte1 and byte2 form 16bits offset to add to pc: offset = (byte1<<8)|(byte2) 
  w1 := js.pop
  w1 := ~~w1 'sign extend b15
  offset := jd.readJavaIntBE(jd.getJvmPC+1)
  if w1 =< 0
    jd.incJvmPC(offset)
  else
    jd.incJvmPC(3)
}
  call         #loadCmpzWord
  if_be        jmp #:doit       ' if w1 <= 0, do jump
  jmp          #incrPC3done
:doit  jmp     #addWordPCdone

'_____________________________________________________________________________
'
doJem_IFGT
''  doJem_IFGT Meaning: Branch if greater than 0.
{
  JEM format: ifgt,byte1,byte2
  byte1 and byte2 form 16bits offset to add to pc: offset = (byte1<<8)|(byte2) 
  w1 := js.pop
  w1 := ~~w1 'sign extend b15
  offset := jd.readJavaIntBE(jd.getJvmPC+1)
  if w1 > 0
    jd.incJvmPC(offset)
  else
    jd.incJvmPC(3)
}
  call         #loadCmpzWord
  if_a         jmp #:doit       ' if w1 > 0, do jump
  jmp          #incrPC3done
:doit  jmp     #addWordPCdone

'_____________________________________________________________________________
'
doJem_IFGE
''  doJem_IFGE Meaning: Branch if greater than or equal to 0.
{
  JEM format: ifge,byte1,byte2
  byte1 and byte2 form 16bits offset to add to pc: offset = (byte1<<8)|(byte2) 
  w1 := js.pop
  w1 := ~~w1 'sign extend b15
  offset := jd.readJavaIntBE(jd.getJvmPC+1)
  if w1 => 0
    jd.incJvmPC(offset)
  else
    jd.incJvmPC(3)
}
  call         #loadCmpzWord
  if_ae        jmp #:doit       ' if w1 >= 0, do jump
  jmp          #incrPC3done
:doit  jmp     #addWordPCdone

'_____________________________________________________________________________
'
doJem_IF_ICMPEQ
''  doJem_IF_ICMPEQ Meaning: Branch if integers v1 and v2 are equal.
{
  JEM format: icmpeq,byte1,byte2
  byte1 and byte2 form 16bits offset to add to pc: offset = (byte1<<8)|(byte2) 
  w2 := js.pop
  w2 := ~~w2 'sign extend b15
  w1 := js.pop
  w1 := ~~w1 'sign extend b15
  offset := jd.readJavaIntBE(jd.getJvmPC+1)
  if w1 == w2
    jd.incJvmPC(offset)
  else
    jd.incJvmPC(3)
}
  call         #loadCmpWords
  if_z         jmp #:doit       ' if w1 == w2, do jump
  jmp          #incrPC3done
:doit  jmp     #addWordPCdone

'_____________________________________________________________________________
'
doJem_IF_ICMPNE
''  doJem_IF_ICMPNE Meaning: Branch if integers v1 and v2 are not equal.
{
  JEM format: icmpne,byte1,byte2
  byte1 and byte2 form 16bits offset to add to pc: offset = (byte1<<8)|(byte2) 
  w2 := js.pop
  w2 := ~~w2 'sign extend b15
  w1 := js.pop
  w1 := ~~w1 'sign extend b15
  offset := jd.readJavaIntBE(jd.getJvmPC+1)
  if w1 <> w2
    jd.incJvmPC(offset)
  else
    jd.incJvmPC(3)
}    
  call         #loadCmpWords
  if_nz        jmp #:doit       ' if w1 <> w2, do jump
  jmp          #incrPC3done
:doit  jmp     #addWordPCdone

'_____________________________________________________________________________
'
doJem_IF_ICMPLT
''  doJem_IF_ICMPLT Meaning: Branch if integer v1 is less than integer v2.
{
  JEM format: icmplt,byte1,byte2
  byte1 and byte2 form 16bits offset to add to pc: offset = (byte1<<8)|(byte2) 
  w2 := js.pop
  w2 := ~~w2 'sign extend b15
  w1 := js.pop
  w1 := ~~w1 'sign extend b15
  offset := jd.readJavaIntBE(jd.getJvmPC+1)
  if w1 < w2
    jd.incJvmPC(offset)
  else
    jd.incJvmPC(3)
}
  call         #loadCmpWords
  if_b         jmp #:doit       ' if w1 < w2, do jump
  jmp          #incrPC3done
:doit  jmp     #addWordPCdone

'_____________________________________________________________________________
'
doJem_IF_ICMPGE
''  doJem_IF_ICMPGE Meaning: Branch if integer v1 is greater than or equal to integer v2.
{
  JEM format: icmpge,byte1,byte2
  byte1 and byte2 form 16bits offset to add to pc: offset = (byte1<<8)|(byte2) 
  w2 := js.pop
  w2 := ~~w2 'sign extend b15
  w1 := js.pop
  w1 := ~~w1 'sign extend b15
  offset := jd.readJavaIntBE(jd.getJvmPC+1)
  if w1 => w2
    jd.incJvmPC(offset)
  else
    jd.incJvmPC(3)
}
  call         #loadCmpWords
  if_ae        jmp #:doit       ' if w1 >= w2, do jump
  jmp          #incrPC3done
:doit  jmp     #addWordPCdone

'_____________________________________________________________________________
'
doJem_IF_ICMPGT
''  doJem_IF_ICMPGT Meaning: Branch if integer v1 is greater than integer v2.
{
  JEM format: icmpgt,byte1,byte2
  byte1 and byte2 form 16bits offset to add to pc: offset = (byte1<<8)|(byte2) 
  w2 := js.pop
  w2 := ~~w2 'sign extend b15
  w1 := js.pop
  w1 := ~~w1 'sign extend b15
  offset := jd.readJavaIntBE(jd.getJvmPC+1)
  if w1 > w2
    jd.incJvmPC(offset)
  else
    jd.incJvmPC(3)
}
  call         #loadCmpWords
  if_a         jmp #:doit       ' if w1 > w2, do jump
  jmp          #incrPC3done
:doit  jmp     #addWordPCdone

'_____________________________________________________________________________
'
doJem_IF_ICMPLE
''  doJem_IF_ICMPLE Meaning: Branch if integer v1 is less than or equal to integer v2.
{
  JEM format: icmple,byte1,byte2
  byte1 and byte2 form 16bits offset to add to pc: offset = (byte1<<8)|(byte2) 
  w2 := js.pop
  w2 := ~~w2 'sign extend b15
  w1 := js.pop
  w1 := ~~w1 'sign extend b15
  offset := jd.readJavaIntBE(jd.getJvmPC+1)
  if w1 =< w2
    jd.incJvmPC(offset)
  else
    jd.incJvmPC(3)
}
  call         #loadCmpWords
  if_be        jmp #:doit       ' if w1 <= w2, do jump
  jmp          #incrPC3done
:doit  jmp     #addWordPCdone

'_____________________________________________________________________________
'
doJem_IF_ACMPEQ
''  doJem_IF_ACMPEQ Meaning: Branch if object references are equal.
{
  JEM format: acmpeq,byte1,byte2
  byte1 and byte2 form 16bits offset to add to pc: offset = (byte1<<8)|(byte2) 
  w2 := js.pop
  w2 := ~~w2 'sign extend b15
  w1 := js.pop
  w1 := ~~w1 'sign extend b15
  offset := jd.readJavaIntBE(jd.getJvmPC+1)
  if w1 == w2
    jd.incJvmPC(offset)
  else
    jd.incJvmPC(3)
}
  jmp          #doJem_IF_ICMPEQ ' functionally equivalent

'_____________________________________________________________________________
'
doJem_IF_ACMPNE
''  doJem_IF_ACMPNE Meaning: Branch if object references are not equal.
{
  JEM format: acmpne,byte1,byte2
  byte1 and byte2 form 16bits offset to add to pc: offset = (byte1<<8)|(byte2) 
  w2 := js.pop
  w2 := ~~w2 'sign extend b15
  w1 := js.pop
  w1 := ~~w1 'sign extend b15
  offset := jd.readJavaIntBE(jd.getJvmPC+1)
  if w1 <> w2
    jd.incJvmPC(offset)
  else
    jd.incJvmPC(3)
}
  jmp          #doJem_IF_ICMPNE ' functionally equivalent

'_____________________________________________________________________________
'
doJem_IRETURN
''  doJem_IRETURN Meaning: Return integer from function.
{
  JEM format: ireturn
  val := js.pop                               'pop return value
  jb_return                                      'discard frame
  js.push(val)                                'push return value
}
  call         #jpop
  mov          t4,  rc          ' t4 is safe
  call         #doJemRETURN
  mov          rc,  t4          
  call         #jpush           ' set return code
  jmp          #jvmDone         

'_____________________________________________________________________________
'
doJem_RETURN
''  doJem_RETURN Meaning: Return (void) from method.
  call         #doJemRETURN
  jmp          #jvmDone
  
doJemRETURN  
{
  JEM format: return
  method := jd.getJvmMP                          'current method
  size := (jd.readJavaByte(method + jd#JVM_PARAMETERS) & $7F) + jd.readJavaByte(method + jd#JVM_LOCALS) 'offset to saved mp,fp,pc in current frame
  sp := jd.getJvmFP + size
  jd.setJvmMP(jd.readJavaIntBE(sp))              'restore mp     
  fp := jd.readJavaIntBE(sp+2)
  jd.setJvmFP(fp)                                'restore fp
  jd.setJvmPC(jd.readJavaIntBE(sp+4))            'restore pc
  sp -= size
  jd.setJvmSP(sp)                                'restore sp
}
  'size = loadByte(mp+pcn#JVM_PARAMETERS)
  rdlong       rc,  mp
  add          rc,  #pcn#JVM_PARAMETERS
  call         #loadByte
  'size&= #$7f
  and          rc,  #$7f
  'size+= loadByte(mp + pcn#JVM_LOCALS)
  mov          t0,  rc  ' t0 = size
  rdlong       rc,  mp
  add          rc,  #pcn#JVM_LOCALS
  call         #loadByte
  add          t0,  rc
  'sp = fp + size
  rdlong       rc,  fp
  add          rc,  t0  ' t0 = size + parms + locals = method
  mov          t1,  rc  ' t1 = sp
  call         #loadWord
  wrlong       rc,  mp  ' restore mp
  'fp = loadWord(sp+2)
  mov          rc,  t1
  add          rc,  #2
  call         #loadWord
  wrlong       rc,  fp  ' restore fp
  'pc = loadWord(sp+4)
  mov          rc,  t1
  add          rc,  #4
  call         #loadWord
  wrlong       rc,  pc  ' restore pc
  'sp -= size
  sub          t1,  t0
  wrlong       t1,  sp  ' restore sp
doJemRETURN_ret ret    

'_____________________________________________________________________________
'
doJem_INVOKEVIRTUAL
''  doJem_INVOKEVIRTUAL Meaning: Invoke method based on runtime type.
{
  JEM format: invokevirtual,byte1,byte2
  byte2 is offset to begin of class method table (so if byte = $2D and class method table = $60, method header = $8D)
  byte1 is offset to sp to find object reference (so if sp = $3FF6 and byte1 = $04 then the aref is at $3FF6-$04 = $3FF2)

  sp := jd.getJvmSP                                       'get sp
  aref := jd.readJavaByte(jd.getJvmPC+1)                  'get offset from sp where aref is stored
  fp := sp - aref                                         'calculate address of possibly new frame
  aref := jd.readJavaIntBE(fp)                            'get aref
  if aref <> 0
    class := jd.readJavaIntBE(aref)                         'get address of class descriptor
    method := jd.readJavaByte(jd.getJvmPC+2) + class        'get address of method descriptor
    if jd.readJavaByte(method + jd#JVM_FLAGS) == $00        'not native
      sp += jd.readJavaByte(method + jd#JVM_LOCALS)         'skip locals     
      jd.writeJavaIntBE(sp,jd.getJvmMP)                     'save old mp
      jd.writeJavaIntBE(sp+2,jd.getJvmFP)                   'save old fp
      jd.writeJavaIntBE(sp+4,jd.getJvmPC+3)                 'save old pc (= return address)
      jd.setJvmSP(sp+6)                                     'set new sp     
      jd.setJvmMP(method)                                   'set new mp
      jd.setJvmFP(fp)                                       'set new fp
      jd.setJvmPC(jd.readJavaIntBE(method + jd#JVM_CODE))   'set new pc
      return -1
    if jd.readJavaByte(method + jd#JVM_FLAGS) == $80        'native
      nf := jd.readJavaIntBE(method + jd#JVM_CODE)          'get native function number
      return nf 'native function is executed from mainloop
  else
    je.throw(je#kNullPointerException)
    return -1
}
'  aref := jd.readJavaByte(jd.getJvmPC+1)                  'get offset from sp where aref is stored
  call         #loadBytePcPlus1
  mov          t0,  rc      ' t0 = aref offset

'  sp := jd.getJvmSP                                       'get sp
  rdlong       rc,  sp      ' t4 = sp
  mov          t4,  rc      ' t4 = sp

'  fp := sp - aref offset                                  'calculate address of new frame
  'mov          rc,  t4      ' rc = t4 = sp
  sub          rc,  t0      ' fp = rc = sp - aref offset
  
'  aref := jd.readJavaIntBE(fp)                            'get aref
  mov          t3,  rc      ' t3 = fp
  call         #loadWord
  tjz          rc,  #throwINVOKEVIRTUAL
  'cmp          rc,  #0   wz
  'if_z  jmp    #throwINVOKEVIRTUAL
'  if aref <> 0
'    class := jd.readJavaIntBE(aref)                       'get address of class descriptor
  rdlong       t1,  hp      ' get heap
  cmp          rc,  t1 wz,wc' if aref >= heap
  if_ae sub    rc,  jem     ' get aref no jem offset
  mov          t0,  rc      ' t0 = aref
  call         #loadWord
  'if_ae call   #swap16
  mov          t1,  rc      ' t1 = class
'    method := jd.readJavaByte(jd.getJvmPC+2) + class        'get address of method descriptor
  rdlong       rc,  pc
  add          rc,  #2
  call         #loadByte
  add          rc,  t1      ' + class
'    if jd.readJavaByte(method + jd#JVM_FLAGS) == $00        'not native
  mov          t2,  rc      ' t2 = method
  add          rc,  #pcn#JVM_FLAGS
  call         #loadByte
  tjnz         rc,  #nativeINVOKEVIRTUAL
  'cmp          rc,  #0 wz
  'if_nz jmp    #nativeINVOKEVIRTUAL
'      sp += jd.readJavaByte(method + jd#JVM_LOCALS)         'skip locals     
  mov          rc,  t2
  add          rc,  #pcn#JVM_LOCALS   
  call         #loadByte    ' local count  
  add          t4,  rc      ' add to sp
'      jd.writeJavaIntBE(sp,jd.getJvmMP)                     'save old mp
  mov          arg1,t4      ' arg1 = sp + pcnt ... sp+0
  rdlong       rc,  mp      ' save old mp
  call         #saveWord    ' save old mp in sp
'      jd.writeJavaIntBE(sp+2,jd.getJvmFP)                   'save old fp
  add          arg1,#2      ' arg1 = sp + pcnt +2 ... sp+2
  rdlong       rc,  fp      ' save fp
  call         #saveWord    ' save old fp in sp
'      jd.writeJavaIntBE(sp+4,jd.getJvmPC+3)                 'save old pc (= return address)
  add          arg1,#2      ' arg1 = sp + pcnt +4 ... sp+4
  rdlong       rc,  pc
  add          rc,  #3      ' save pc+3 ... return address
  call         #saveWord
'      jd.setJvmSP(sp+6)                                     'set new sp     
  add          arg1,#2      ' sp + 6
  wrlong       arg1,sp      ' save sp + 6
'      jd.setJvmFP(fp)                                       'set new fp
  wrlong       t3,  fp      ' t3 = fp
'      jd.setJvmMP(method)                                   'set new mp
  wrlong       t2,  mp      ' t2 = method
'      jd.setJvmPC(jd.readJavaIntBE(method + jd#JVM_CODE))   'set new pc
  mov          rc,  t2      ' t2 = method
  add          rc, #pcn#JVM_CODE
  call         #loadWord
  wrlong       rc, pc       ' save pc  
'      return -1
  jmp          #jvmDone
nativeINVOKEVIRTUAL    
'    if jd.readJavaByte(method + jd#JVM_FLAGS) == $80        'native
'      nf := jd.readJavaIntBE(method + jd#JVM_CODE)          'get native function number
'      return nf 'native function is executed from mainloop
  ' method is native
  mov          rc,  t2      ' t2 = method
  add          rc, #pcn#JVM_CODE
  call         #loadWord
  add          rc,  #NATIVE_BIT ' bit flags native command
  wrlong       rc,  cmdp        ' set native command
  jmp          #jvmDone
throwINVOKEVIRTUAL
'  else
'    je.throw(je#kNullPointerException)
'    return -1
  mov          rc,EXCPTN
  wrlong       rc,cmdp        ' set exception command
endINVOKEVIRTUAL  
  jmp          #jvmDone

'_____________________________________________________________________________
'
doJem_INVOKESTATIC
''  doJem_INVOKESTATIC Meaning: Invoke a class (static) method.
{
  JEM format: invokestatic,byte1,byte2
  byte1 and byte2 form 16bits address to method header: addr = (byte1<<8)|(byte2) 

  sp := jd.getJvmSP                                       'get sp
  method := jd.readJavaIntBE(jd.getJvmPC+1)               'get address of method descriptor
  fp := sp - (jd.readJavaByte(method + jd#JVM_PARAMETERS) & $7F)  'calculate address of possible new frame (mask out exception bit)
  if jd.readJavaByte(method + jd#JVM_FLAGS) == $00        'not native
    sp += jd.readJavaByte(method + jd#JVM_LOCALS)         'skip locals     
    jd.writeJavaIntBE(sp,jd.getJvmMP)                     'save old mp
    jd.writeJavaIntBE(sp+2,jd.getJvmFP)                   'save old fp
    jd.writeJavaIntBE(sp+4,jd.getJvmPC+3)                 'save old pc (= return address)
    jd.setJvmFP(fp)                                       'set new fp
    jd.setJvmMP(method)                                   'set new mp
    jd.setJvmSP(sp+6)                                     'set new sp     
    jd.setJvmPC(jd.readJavaIntBE(method + jd#JVM_CODE))   'set new pc
    return -1
  if jd.readJavaByte(method + jd#JVM_FLAGS) == $80        'native
    nf := jd.readJavaIntBE(method + jd#JVM_CODE)          'get native function number
    return nf 'native function is executed from mainloop
}
'  method := jd.readJavaIntBE(jd.getJvmPC+1)               'get address of method descriptor
  call         #loadWordPcPlus1
  mov          t0,  rc      ' t0 = method
'  fp := sp - (jd.readJavaByte(method + jd#JVM_PARAMETERS) & $7F)  'calculate address of possible new frame (mask out exception bit)
  add          rc,  #pcn#JVM_PARAMETERS
  call         #loadByte
  mov          t2,  rc      ' t2 = parameter count
  and          t2,  #$7f
'  sp := jd.getJvmSP                                       'get sp
  rdlong       rc,  sp      ' get sp
  mov          t3,  rc      ' t3 = sp
'  fp := sp - parameter count
  sub          rc,  t2      ' rc = fp = sp - t2 parm count
  mov          t1,  rc      ' t1 = fp
  mov          rc,  t0      ' t0 = method
'  if jd.readJavaByte(method + jd#JVM_FLAGS) == $00        'not native
  add          rc,  #pcn#JVM_FLAGS
  call         #loadByte    
'  if not zero, native
  cmp          rc,  #0   wz ' if flags == 0, method is not-native
  if_nz jmp    #nativeINVOKESTATIC
'    sp += jd.readJavaByte(method + jd#JVM_LOCALS)         'skip locals     
  mov          rc,  t0      ' t0 = method
  add          rc,  #pcn#JVM_LOCALS   
  call         #loadByte    ' local count
  add          t3,  rc      ' add to sp  t3 = sp
'    jd.writeJavaIntBE(sp,jd.getJvmMP)                     'save old mp
  mov          arg1,t3      ' arg1 = sp + pcnt
  rdlong       rc,  mp                           
  call         #saveWord    ' save old MP in sp
'    jd.writeJavaIntBE(sp+2,jd.getJvmFP)                   'save old fp
  add          arg1,#2      ' arg1 = sp + pcnt + 2
  rdlong       rc,  fp
  call         #saveWord    ' save old FP in sp+2
'    jd.writeJavaIntBE(sp+4,jd.getJvmPC+3)                 'save old pc (= return address)
  add          arg1,#2      ' arg1 = sp + pcnt + 4
  rdlong       rc,  pc
  add          rc,  #3
  call         #saveWord    ' save old PC+3 in sp+4 ... return address
'    jd.setJvmSP(sp+6)                                     'set new sp     
  add          arg1,#2      ' arg1 = sp + pcnt + 6
  wrlong       arg1,sp      ' save sp+6
'    jd.setJvmFP(fp)                                       'set new fp
  wrlong       t1,  fp      ' save fp
'    jd.setJvmMP(method)                                   'set new mp
  mov          rc,  t0      ' t0 = method 
  wrlong       rc,  mp      ' save mp
'    jd.setJvmPC(jd.readJavaIntBE(method + jd#JVM_CODE))   'set new pc
  add          rc, #pcn#JVM_CODE
  call         #loadWord    ' get method + code
  wrlong       rc,  pc      ' set new pc  
'    return -1
  jmp          #jvmDone
'  if jd.readJavaByte(method + jd#JVM_FLAGS) == $80        'native
nativeINVOKESTATIC
  ' method is native
'    nf := jd.readJavaIntBE(method + jd#JVM_CODE)          'get native function number
  mov          rc,  t0      ' t0 = method
  add          rc, #pcn#JVM_CODE
  call         #loadWord
'    return nf 'native function is executed from mainloop
  add          rc,  #NATIVE_BIT       ' bit flags native command
  wrlong       rc,  cmdp        ' set native command
  jmp          #jvmDone



'_____________________________________________________________________________
'
doJem_GETSTATIC
''  doJem_GETSTATIC Meaning: Get 32-bit static field from class.
{
  JEM format: getstatic,byte1,byte2
  byte1 and byte2 form 16bits offset into static variables area: offset = (byte1<<8)|(byte2) 

  offset := jd.readJavaIntBE(jd.getJvmPC+1)
  value := jd.getStatic(offset)
  js.push(value) 'return value
  jd.incJvmPC(3)
}  
'  offset := jd.readJavaIntBE(jd.getJvmPC+1)
  call         #loadWordPcPlus1
  mov          arg1,rc      ' arg1 = offset
'  value := jd.getStatic(offset)
  call         #getStatic   ' rc = value
'  js.push(value) 'return value
'  jd.incJvmPC(3)
  jmp          #pushIncrPC3done

'_____________________________________________________________________________
'
doJem_PUTSTATIC
''  doJem_PUTSTATIC Meaning: Set 32-bit static field in class.
{
  JEM format: putstatic,byte1,byte2
  byte1 and byte2 form 16bits offset into static variables area: offset = (byte1<<8)|(byte2) 

  value := js.pop 'get value
  offset := jd.readJavaIntBE(jd.getJvmPC+1)
  jd.putStatic(offset,value)
  jd.incJvmPC(3)
}
'  value := js.pop 'get value
  call         #jpop
  mov          t1,  rc      ' t1 = value
'  offset := jd.readJavaIntBE(jd.getJvmPC+1)
  call         #loadWordPcPlus1
  mov          arg1,rc      ' arg1 = offset
  mov          rc,  t1
'  jd.putStatic(offset,value)
  call         #setStatic
'  jd.incJvmPC(3)
  jmp          #incrPC3done

'_____________________________________________________________________________
'
''  doJem_NotUsed Meaning: Handle unused bytecode.

doJem_NotUsed
  jmp          #jvmDone

'_____________________________________________________________________________
'
' jpush
' long  rc
'
jpush
  rdword       tp,  sp
  add          tp,  jem
  call         #swap16  
  wrword       rc,  tp
  add          tp,  #2
  sub          tp,  jem
  wrword       tp,  sp
jpush_ret      ret

'_____________________________________________________________________________
'
' jpop
' long  rc
'
jpop
  rdword       tp,  sp
  add          tp,  jem
  sub          tp,  #2
  rdword       rc,  tp
  call         #swap16  
  sub          tp,  jem
  wrword       tp,  sp
jpop_ret       ret

'_____________________________________________________________________________
'
' swap16
' long  rc
swap          long 0 ' temporary for swap
swap16
  and          rc,Minus1    ' prevent overflow  
  mov          swap,rc
  and          rc,  #$ff
  shr          swap,#8
  shl          rc,  #8
  or           rc, swap
swap16_ret     ret

'_____________________________________________________________________________
'
' setWord16
' long  rc
setWord16                
  and          arg1, Minus1    ' prevent overflow  
  shl          arg1, #8
  or           arg1, arg2
  mov          rc,   arg1
setWord16_ret  ret

'_____________________________________________________________________________
'
' loadBytePcPlus1
' long  rc
'
loadBytePcPlus1
  rdlong       rc,  pc
  add          rc,  jem
  add          rc,  #1   ' add pc+1
  rdbyte       rc,  rc   ' read byte at pc+1
loadBytePcPlus1_ret      ret

'_____________________________________________________________________________
'
' loadWordPcPlus1
' long  rc
'
loadWordPcPlus1
  rdlong       rc,  pc
  add          rc,  jem
  add          rc,  #1   ' add pc+1
  rdbyte       arg1,rc   ' read byte
  add          rc,  #1
  rdbyte       arg2,rc   ' read byte
  call         #setWord16
loadWordPcPlus1_ret      ret

'_____________________________________________________________________________
'
' loadByte
' long  rc
'
loadByte
  add          rc,  jem
  rdbyte       rc,  rc   ' read byte at pc+1
loadByte_ret   ret

'_____________________________________________________________________________
'
' loadWord
' long  rc
'
loadWord
  add          rc,  jem
  rdbyte       arg1,rc   ' read byte
  add          rc,  #1
  rdbyte       arg2,rc   ' read byte
  call         #setWord16' ends with word in rc
loadWord_ret   ret

'_____________________________________________________________________________
'
' saveByte
' long  arg1 = address
' long  rc = data
'
saveByte
  mov          tp,  arg1 ' get bytecode base
  add          tp,  jem
  wrbyte       rc,  tp ' write byte
saveByte_ret   ret

'_____________________________________________________________________________
'
' saveWord
' long  arg1 = address
' long  rc = data
'
saveWord
  mov          tp,  arg1 ' get bytecode base
  add          tp,  jem
  add          tp,  #1
  wrbyte       rc,  tp   ' write word
  shr          rc,  #8
  sub          tp,  #1
  wrbyte       rc,  tp   ' write word
saveWord_ret   ret

'_____________________________________________________________________________
'
' signExtend16
' long  rc
signExtend16
  test         rc,  MSB16 wz
  if_nz or     rc,  M1WDXT
signExtend16_ret   ret

'_____________________________________________________________________________
' loadCmpzWord
' long arg1 = word to compare
' long  rc  = offset for jmp 
loadCmpzWord
  call         #jpop
  call         #signExtend16
  mov          arg1,rc          ' w1
  mov          t1, arg1
  rdlong       rc,  pc
  add          rc,  #1
  call         #loadWord        ' rc = offset
  mov          arg1, t1
  cmps         arg1,#0  wz,wc
loadCmpzWord_ret    ret

'_____________________________________________________________________________
' loadCmpWords
' returns
' long arg1 = word 1 to compare
' long arg2 = word 2 to compare
' long  rc  = offset for jmp 
loadCmpWords
  call         #pop2signed
  mov          t1, arg1         ' w1
  mov          t2, arg2         ' w2
  rdlong       rc,  pc          ' get pc
  add          rc,  #1          ' load word at pc+1
  call         #loadWord        ' rc = offset
  mov          arg1, t1
  mov          arg2, t2
  cmps         arg1,arg2 wz,wc
loadCmpWords_ret    ret

'_____________________________________________________________________________
'
' pop2signed
' long  arg1
' long  arg2
pop2signed
  call         #jpop
  call         #signExtend16
  mov          arg2,rc          ' w2
  call         #jpop
  call         #signExtend16
  mov          arg1,rc          ' w1
pop2signed_ret ret


'_____________________________________________________________________________
'
pushIncrPCdone        
  call         #jpush
incrPCdone
  rdlong       rc,  pc
  add          rc,  #1
  wrlong       rc,  pc
  jmp          #jvmDone

'_____________________________________________________________________________
'
pushIncrPC2done        
  call         #jpush
incrPC2done
  rdlong       rc,  pc
  add          rc,  #2
  wrlong       rc,  pc
  jmp          #jvmDone

'_____________________________________________________________________________
'
pushIncrPC3done        
  call         #jpush
incrPC3done
  rdlong       rc,  pc
  add          rc,  #3
  wrlong       rc,  pc
  jmp          #jvmDone

'_____________________________________________________________________________
'
addWordPCdone
  call         #signExtend16
  mov          arg1,rc
addPCdone
  rdlong       rc,  pc
  add          rc,  arg1
  wrlong       rc,  pc
  jmp          #jvmDone

'_____________________________________________________________________________
' arg1 = offset
' rc   = value
setStatic
  rdlong       tp, sbp
  add          tp, arg1
  wrword       rc, tp           ' word wide for 16 bit JVM
setStatic_ret      ret

'_____________________________________________________________________________
' arg1 = offset
getStatic
  rdlong       tp, sbp
  add          tp, arg1
  rdword       rc, tp           ' word wide for 16 bit JVM
getStatic_ret  ret


'_____________________________________________________________________________
'
' support constants
'
MINUS1  long   $FFFF    ' 16 bit machine
M1BXT   long   $FF00
MSB16   long   $8000
M1WDXT  long   $FFFF0000
M32K    long   -32767
P32K    long   32768
EXCPTN  long   $8000
zero    long   0

'_____________________________________________________________________________
'                         
' call variables
'
arg1    long 0
arg2    long 0
arg3    long 0
rc      long 0
parm    long 0

'_____________________________________________________________________________
'
' local variables
'
pp      long 0
tp      long 0
t0      long 0
t1      long 0
t2      long 0
t3      long 0
t4      long 0

'_____________________________________________________________________________
'
' spin command interface
'
cmdp    long 0    ' shared jvm instruction pointer
ctrp    long 0    ' control pointer 0 if nothing to do
jemp    long 0    ' not a rdlong pointer

'_____________________________________________________________________________
'
' jvm  variables
'
pc      long 0    ' program counter pointer
bp      long 0    ' stack base pointer
sp      long 0    ' stack pointer
fp      long 0    ' frame pointer
mp      long 0    ' method pointer
ap      long 0    ' allocated heap pointer
hp      long 0    ' heap end pointer
ep      long 0    ' exception pointer
cp      long 0    ' carry pointer
sbp     long 0    ' static base pointer
strp    long 0    ' strings pointer
tap1    long 0    ' jump table pointer1
tap2    long 0    ' jump table pointer2
tap3    long 0    ' jump table pointer3

jem     long 0    ' jem base

  fit   $1f0
'_____________________________________________________________________________
'

'{
dat     '' pasm implementing jvm
jvm2           org 0
  long 0 [8]  ' for debugger

  mov          j2tp,  par

  mov          j2t1,  #j2cmdp
  mov          j2t0,  #pcn#JVM_ENG_NOOFPARMS         ' noof parameters
j2ploop
  movd  j2pwrite,j2t1
  add   j2t1,    #1
j2pwrite  mov    0-0, j2tp
  add          j2tp, #4
  djnz         j2t0,  #j2ploop
  
jvm2loop
  rdlong       j2rc,  j2ctrp wz
  if_z  jmp    #jvm2loop
  rdlong       j2rc,  j2pc
  rdlong       j2jem, j2jemp            ' get jem offset

  rdlong       j2rc,  j2cmdp
  cmp          j2rc,  #pcn#Jem_POP wz,wc' 0 is a valid opcode
  if_b  jmp    #jvm2loop
  cmp          j2rc,  #pcn#Jem_NEW wz,wc
  if_a  jmp    #jvm2loop
  
  rdlong       j2tp,  j2tap2            ' get table base address
  sub          j2rc,  #pcn#Jem_POP   
  shl          j2rc,  #1
  add          j2tp,  j2rc              ' get j2tap[j2rc] address
  rdword       j2t0,  j2tp              ' get j2tap[j2rc] value
  movs         j2jmpit,j2t0             ' set routine address
  nop  
j2jmpit  jmp    #0-0                    ' jmp bytecode routine

jvm2done
  mov          j2rc, #0
  wrlong       j2rc, j2ctrp       
  jmp   #jvm2loop


'_____________________________________________________________________________
'
doJem_POP
'doc  doJem_POP Meaning: Pop the top word from the stack.
{
  JEM format: pop
  val := pop
  jd.incJvmPC(1)
  return val   ' not used in jvmEngine
}
  call         #j2pop
  jmp          #j2incrPCdone

'_____________________________________________________________________________
'
doJem_POP2
'doc  doJem_POP2 Meaning: Pop the top two words from the stack.
{
  JEM format: pop2
  w1 := pop  'lsw
  w2 := pop  'msw
  jd.incJvmPC(1)
  return (w2 << 16) | w1  'return 32bits result ' not used in jvmEngine
}
  call         #j2pop
  mov          j2t0,  j2rc   ' w1 = lsw
  call         #j2pop    
  shl          j2rc,  #16  ' w2 = msw
  or           j2rc,  j2t0
  jmp          #j2incrPCdone

'_____________________________________________________________________________
'
doJem_DUP
'doc  doJem_DUP Meaning: Duplicate the top word on the stack.
{
  JEM format: dup
  w1 := pop
  push(w1)
  push(w1)
  jd.incJvmPC(1)
}
  call         #j2pop
  call         #j2push
  jmp          #j2pushIncrPCdone


'_____________________________________________________________________________
'
doJem_DUP_X1
'doc  doJem_DUP_X1 Meaning: Duplicate the top word on the stack and insert a copy two words down in the stack.
{
  JEM format: dup_x1
  w1 := pop
  w2 := pop
  push(w1)
  push(w2)
  push(w1)
  jd.incJvmPC(1)
}
  call         #j2pop1
  call         #j2pop2
  jmp          #j2push121_incrPCdone

'_____________________________________________________________________________
'
doJem_DUP_X2
'doc  doJem_DUP_X2 Meaning: Duplicate the top word on the stack and insert the copy three words down in the stack.
{
  JEM format: dup_x2
  w1 := pop
  w2 := pop
  w3 := pop
  push(w1)
  push(w3)
  push(w2)
  push(w1)
  jd.incJvmPC(1)
}
  call         #j2pop1
  call         #j2pop2
  call         #j2pop3
  call         #j2push1
  jmp          #j2push321_incrPCdone

'_____________________________________________________________________________
'
doJem_DUP2
'doc  doJem_DUP2 Meaning: Duplicate the top two words on the stack.
{
  JEM format: dup2
  w1 := pop
  w2 := pop
  push(w2)
  push(w1)
  push(w2)
  push(w1)
  jd.incJvmPC(1)
}
  call         #j2pop1
  call         #j2pop2
  jmp          #j2push2121_incrPCdone

'_____________________________________________________________________________
'
doJem_DUP2_X1
'doc  doJem_DUP2_X1 Meaning: Duplicate the top two words on the stack and insert the copies two words down in the stack.
{
  JEM format: dup2_x1

  w1 := pop
  w2 := pop
  w3 := pop
  push(w2)
  push(w1)
  push(w3)
  push(w2)
  push(w1)
  jd.incJvmPC(1)
}
  call         #j2pop1
  call         #j2pop2
  call         #j2pop3
  call         #j2push2
  call         #j2push1
  jmp          #j2push321_incrPCdone

'_____________________________________________________________________________
'
doJem_DUP2_X2
'doc  doJem_DUP2_X2 Meaning: Duplicate the top two words on the stack and insert the copies three words down in the stack.
{
  JEM format: dup2_x2

  w1 := pop
  w2 := pop
  w3 := pop
  w4 := pop
  push(w2)
  push(w1)
  push(w4)
  push(w3)
  push(w2)
  push(w1)
  jd.incJvmPC(1)
}
  call         #j2pop1
  call         #j2pop2
  call         #j2pop3
  call         #j2pop4
  jmp          #j2push214321_incrPCdone

'_____________________________________________________________________________
'
doJem_SWAP
'doc  doJem_SWAP Meaning: Swap the top two elements on the stack.
{
  JEM format: swap

  w1 := pop
  w2 := pop
  push(w1)
  push(w2)
  jd.incJvmPC(1)
}
  call         #j2pop1
  call         #j2pop2
  jmp          #j2push21_incrPCdone


j2push2121_incrPCdone
  call         #j2push2
j2push121_incrPCdone
  call         #j2push1
j2push21_incrPCdone
  call         #j2push2
  call         #j2push1
  jmp          #j2incrPCdone

j2push214321_incrPCdone
  call         #j2push2
  call         #j2push1
j2push4321_incrPCdone
  call         #j2push4
j2push321_incrPCdone
  call         #j2push3
  call         #j2push2
  call         #j2push1
  jmp          #j2incrPCdone

'_____________________________________________________________________________
'
doJem_IADD
'doc  doJem_IADD Meaning: Integer add.
{                                                                                    
  JEM format: iadd

  w2 := js.pop
  w2 := ~~w2 'sign extend b15
  w1 := js.pop
  w1 := ~~w1 'sign extend b15
  w1 := w1 + w2
  jd.clearCarry
  if w1 < -32768 OR w1 > 32767
    jd.setCarry
}
'{
  call         #j2pop2signed    ' j2arg1 = w2, j2arg2 = w1
  add          j2arg2,  j2arg1 wc
  if_nc wrlong j2one,   j2cp   'call   #j2setCarry
  if_c  wrlong j2zero,  j2cp   'call   #j2clrCarry
  and          j2arg2,  j2Minus1  
  jmp          #j2mvRcIncrPCdone
'}

{ works about the same
  call         #j2poparg12     ' j2arg1 = w2, j2arg2 = w1
  add          j2arg2,  j2arg1
  test         j2arg2,  j2M1WDXT wz
  if_z  wrlong j2one,   j2cp   'call   #j2setCarry
  if_nz wrlong j2zero,  j2cp   'call   #j2clrCarry
  and          j2arg2,  j2Minus1  
  jmp          #j2mvRcIncrPCdone
'}

'_____________________________________________________________________________
'
doJem_ISUB
''  doJem_ISUB Meaning: Integer subtract.
{
  JEM format: isub

  w2 := js.pop
  w2 := ~~w2 'sign extend b15
  w1 := js.pop
  w1 := ~~w1 'sign extend b15
  w1 := w1 - w2
  jd.clearCarry
  if w1 < -32768 OR w1 > 32767
    jd.setCarry
  js.push(w1)
  jd.incJvmPC(1)
}

{
  call         #j2poparg12     ' j2arg1 = w2, j2arg2 = w1
  sub          j2arg2,  j2arg1  wc
  if_c  wrlong j2one,   j2cp   'call   #j2setCarry
  if_nc wrlong j2zero,  j2cp   'call   #j2clrCarry
  and          j2arg2,  j2Minus1  
  jmp          #j2mvRcIncrPCdone
'}

'{
  call         #j2pop2signed   ' j2arg1 = w2, j2arg2 = w1
  sub          j2arg2,  j2arg1  wc    ' result of sign extend should be correct carry
  if_c  wrlong j2one,   j2cp   'call   #j2setCarry
  if_nc wrlong j2zero,  j2cp   'call   #j2clrCarry
  and          j2arg2,  j2Minus1  
  jmp          #j2mvRcIncrPCdone
'}

'_____________________________________________________________________________
'
doJem_INEG
''  doJem_INEG Meaning: Integer negate.
{
  JEM format: ineg

  w1 := js.pop
  w1 := ~~w1 'sign extend b15
  w1 := -w1
  js.push(w1)
  jd.incJvmPC(1)
}
  call         #j2pop
  cmp          j2rc,  #0 wz
  if_z jmp     #j2pushIncrPCdone
  and          j2rc,  j2MINUS1  ' 16 bits
  xor          j2rc,  j2MINUS1  ' invert
  add          j2rc,  #1        ' java uses two's complement
  jmp          #j2pushIncrPCdone

'_____________________________________________________________________________
'
doJem_IOR
''  doJem_IOR Meaning: Integer bitwise or.
{
  JEMformat: ior

  w2 := js.pop
  w1 := js.pop
  w1 |= w2
  js.push(w1)
  jd.incJvmPC(1)
}
  call         #j2poparg12
  or           j2arg2,j2arg1   ' w1,w2
  jmp          #j2mvRcIncrPCdone

'_____________________________________________________________________________
'
doJem_ISHL
''  doJem_ISHL Meaning: Integer shift left.
{
  JEM format: ishl

  w2 := js.pop
  w1 := js.pop
  w1 <<= w2
  js.push(w1)
  jd.incJvmPC(1)
}

{
  call         #j2poparg12
  and          j2arg1,#$1f
  mov          j2rc,  j2arg2
  call         #j2signExtend16
  shl          j2rc,j2arg1
  test         j2rc,j2Minus1    wz
  if_nz wrlong j2one, j2cp      ' set carry  
  jmp          #j2pushIncrPCdone
'}
'{
  call         #j2pop2signed
  and          j2arg1,#$1f
  shl          j2arg2,j2arg1    ' w1,w2
  test         j2rc,j2Minus1    wz
  if_nz wrlong j2one, j2cp      ' set carry  
  jmp          #j2mvRcIncrPCdone   
'}

'_____________________________________________________________________________
'
doJem_ISHR
''  doJem_ISHR Meaning: Integer arithmetic shift right.
{
  JEM foramt: ishr

  w2 := js.pop
  w1 := js.pop
  w1 ~>= w2
  js.push(w1)
  jd.incJvmPC(1)
}
{
  call         #j2poparg12
  and          j2arg1,#$1f
  mov          j2rc,  j2arg2
  call         #j2signExtend16
  sar          j2rc,j2arg1
  jmp          #j2pushIncrPCdone
'}
'{
  call         #j2pop2signed
  and          j2arg1,#$1f
  sar          j2arg2,j2arg1    ' w1,w2
  jmp          #j2mvRcIncrPCdone
'}
'_____________________________________________________________________________
'
doJem_IUSHR
''  doJem_IUSHR Meaning: Integer logical shift right.
{                 
  JEM format: iushr

  w2 := js.pop
  w1 := js.pop
  w1 >>= w2
  js.push(w1)
  jd.incJvmPC(1)
}  
  call         #j2poparg12
  and          j2arg1,#$1f
  shr          j2arg2,j2arg1
  jmp          #j2mvRcIncrPCdone

'_____________________________________________________________________________
'
doJem_IAND
''  doJem_IAND Meaning: Integer bitwise and.
{
  JEM format: iand

  w2 := js.pop
  w1 := js.pop
  w1 &= w2
  js.push(w1)
  jd.incJvmPC(1)
}
  call         #j2poparg12
  and          j2arg2,j2arg1
  jmp          #j2mvRcIncrPCdone

'_____________________________________________________________________________
'
doJem_IXOR
''  doJem_IXOR Meaning: Integer bitwise xor.
{
  JEM format: ixor

  w2 := js.pop
  w1 := js.pop
  w1 ^= w2
  js.push(w1)
  jd.incJvmPC(1)
}
  call         #j2poparg12
  xor          j2arg2,j2arg1
  jmp          #j2mvRcIncrPCdone

j2mvRcIncrPCdone
  mov          j2rc,  j2arg2
  jmp          #j2pushIncrPCdone



'_____________________________________________________________________________
'
doJem_I2B
''  doJem_I2B Meaning: Integer to signed byte.
{
  JEM format: i2b

  w1 := js.pop
  w1 &= $FF
  js.push(w1)
  jd.incJvmPC(1)
}
  call         #j2pop
  and          j2rc,  #$ff
  jmp          #j2pushIncrPCdone

'_____________________________________________________________________________
'
doJem_GOTO
''  doJem_GOTO Meaning: Branch.
{
  Description: Execution proceeds at the signed 16-bit offset from the address of this instruction.
  The offset is constructed from byte1 and byte2.


  JEM format: goto,byte1,byte2
  byte1 and byte2 form 16bits offset to add to pc: offset = (byte1<<8)|(byte2) 

  offset := jd.readJavaIntBE(jd.getJvmPC+1)
  jd.incJvmPC(offset)
}
  call         #j2loadWordPcPlus1
'  call         #j2addPC
  call         #j2signExtend16
  rdlong       j2tp, j2pc
  add          j2tp, j2rc
  wrlong       j2tp, j2pc
  jmp          #jvm2done
  
'_____________________________________________________________________________
'
doJem_INVOKEINTERFACE           ' appears to be unused
  jmp          #jvm2done

'_____________________________________________________________________________
'
doJem_ARRAYLENGTH
'' doJem_ARRAYLENGTH Meaning: Get length of array.
{
  Description: The length of the array is determined and replaces aref on the top of the stack. 
  The aref must be a reference to an array object. 
  Note:
  A NullPointerException is thrown if the aref is null.

  aref := js.pop 'get reference
  if aref <> 0
    len := jd.readJavaIntBE(aref + 2)
    js.push(len)
    jd.incJvmPC(1)
  else
    je.throw(je#kNullPointerException)
}
'  aref := js.pop 'get reference
  call         #j2pop
'  if aref == 0
'    je.throw(je#kNullPointerException)
  cmp          j2rc,  #0 wz
  if_z  jmp    #alenException
  rdlong       j2t2,  j2hp  ' get heap
  cmp          j2rc,  j2t2 wz,wc ' if aref >= heap
  if_ae sub    j2rc,  j2jem ' get aref no jem offset
'  if aref <> 0
  add          j2rc,  #2
'    len := jd.readJavaIntBE(aref + 2)
  call         #j2loadWord
'    js.push(len)
'    jd.incJvmPC(1)
  jmp          #j2pushIncrPCdone
alenException
  mov          j2rc,  j2EXCPTN    
  wrlong       j2rc,  j2cmdp
  jmp          #jvm2done

'_____________________________________________________________________________
'
doJem_ATHROW
'' doJem_ATHROW Meaning: Throw exception or error.
{{
  The objectref must be of type reference and must refer to an object that is an instance of class Throwable or
  of a subclass of Throwable. It is popped from the operand stack. The objectref is then thrown by seaj2rching the
  current method for the first exception handler that matches the class of objectref.
  If an exception handler that matches objectref is found, it contains the location of the code intended to handle
  this exception. The pc register is reset to that location, the operand stack of the current frame is cleared,
  objectref is pushed back onto the operand stack, and execution continues. 
  If no matching exception handler is found in the current frame, that frame is popped. If the current frame
  represents an invocation of a synchronized method, the monitor acquired or reentered on invocation of the method
  is released or exited (respectively) as if by execution of a monitorexit instruction.
  Finally, the frame of its invoker is reinstated, if such a frame exists, and the objectref is rethrown.
  If no such frame exists, the current thread exits.
}}
{{
  JEM format: athrow

  aref := js.pop 'get objectref
  'throwException(aref)
  'Auxiliary function (no bytecode): Throw an exception
  if e <> 0
    if jd.getJvmEP == 0
      jd.setJvmEP(jd.getJvmPC) 'set exception if not already set
    repeat
      exceptionTable := jd.readJavaIntBE(jd.getJvmMP + jd#JVM_EXCEPTION) 'get address of exception table
      numExceptions := 0
      if exceptionTable <> 0
        numExceptions := jd.readJavaByte(exceptionTable) 'read number of exception handlers
      index := 0
      repeat while numExceptions > 0
        if jd.getJvmPC => jd.readJavaIntBE(exceptionTable + 1 + index) AND jd.getJvmPC < jd.readJavaIntBE(exceptionTable + 3 + index)
          if instanceOf(e,jd.readJavaIntBE(exceptionTable + 5 + index))
            'clear operand stack
            paramsize := (jd.readJavaByte(jd.getJvmMP + jd#JVM_PARAMETERS) & $7F) 'mask out exception bit
            localsize := jd.readJavaByte(jd.getJvmMP + jd#JVM_LOCALS)
            sp := jd.getJvmFP + paramsize + localsize + 6
            jd.setJvmSP(sp)
            'push exception
            js.push(e)
            'jump to handler
            pc := jd.readJavaIntBE(exceptionTable + 7 + index)
            jd.setJvmPC(pc)
            return
        index += 8 'size of exception record
        numExceptions--
      jsub.jb_return  'pop frame
    until jd.getJvmMP == $FFFF
    class := jd.readJavaIntBE(e)
    comm.errException(class,jd.getJvmEP) 'signal exception to IDE
    jd.setJvmEP(0) 'clear exception
  else
    throw(kNullPointerException)  
}}
  jmp          #jvm2done

'_____________________________________________________________________________
'
doJem_CHECKCAST
'' doJem_CHECKCAST Meaning: Make sure object is of given type.
{
  Description: Determines whether the referenced object can be cast to be a reference to an 
  object of another class. A null object reference can be cast to any class. Otherwise, the 
  referenced object must be an instance of the expected class or one of its supej2rclasses. byte1  
  and byte2 are used to construct an index into the constant pool of the current class, which is 
  presumed to be a class name that can be resolved to a class pointer. 
  Note:
  A ClassCastException is thrown if the referenced object cannot be cast to the expected class.

  JEM format: checkcast,byte1,byte2
  byte1 and byte2 are always 0 (so this bytecode does not do anything)

  jd.incJvmPC(3)
}
  jmp          #j2incrPC3done

'_____________________________________________________________________________
'
doJem_INSTANCEOF
'' doJem_INSTANCEOF Meaning: Determine if an object is of given type and return result.
{
  Description: Determines whether the referenced object can be cast to be a reference to an 
  object of the expected class. This instruction will overwrite the object reference with 1 if the 
  object is an instance of the expected class or one of its supej2rclasses. Otherwise, the object 
  reference is overwritten by 0.
 
  JEM format: instanceof,byte1,byte2
  byte1 and byte2 form 16bits offset to class header: offset = (byte1<<8)|(byte2) 

  instance := js.pop 'get instance reference
  class := jd.readJavaIntBE(jd.getJvmPC+1) 'class type
  instanceclass := jd.readJavaIntBE(instance) 'get class type for instance
  repeat
    if instanceclass == class
      js.push(1)
      jd.incJvmPC(3)
      return
    else
      instanceclass := jd.readJavaIntBE(instanceclass) 'get supej2rclass of instance
  until instanceclass == $FFFF '$FFFF is supej2rclass of Object class
  js.push(0)
  jd.incJvmPC(3)
}
  call         #j2pop
  mov          j2t0,  j2rc  ' j2t0 = instance
  call         #j2loadWordPcPlus1
  mov          j2t1,  j2rc  ' j2t1 = class
  mov          j2rc,  j2t0
  call         #j2loadWord
  mov          j2t2,  j2rc  ' j2t2 = instanceclass
loopINSTANCEOF
  cmp          j2t1,  j2t2 wz
  if_z  mov    j2rc,  #1
  if_z  call   #j2push
  if_z  jmp    #j2incrPC3done
  mov          j2rc,  j2t2
  call         #j2loadWord
  cmp          j2rc, j2MINUS1 wz
  if_nz jmp    loopINSTANCEOF
  mov          j2rc,  #0
  'call         #j2push
  jmp          #j2pushIncrPC3done

'_____________________________________________________________________________
' 
doJem_WIDE                  ' not used
  jmp          #jvm2done

'_____________________________________________________________________________
'
doJem_IINC
'' doJem_IINC Meaning: Increment local variable by constant.
{
  JEM format: iinc,byte1,byte2
  byte1 is the index of the local variable. byte2 is the signed 1byte value to add to local variable.
  index := jd.readJavaByte(jd.getJvmPC+1)
  val := jd.readJavaByte(jd.getJvmPC+2)
  val := jc.b2i(val)
  fp := jd.getJvmFP
  val += jd.readJavaIntBE(fp + (index<<1))
  jd.writeJavaIntBE(fp + (index<<1),val)
  jd.incJvmPC(3)
}
'  index := jd.readJavaByte(jd.getJvmPC+1)
  call         #j2loadBytePcPlus1
  mov          j2t0,  j2rc      ' j2t0 = index
'  val := jd.readJavaByte(jd.getJvmPC+2)
  rdlong       j2rc,  j2pc
  add          j2rc,  #2
  call         #j2loadByte
'  val := jc.b2i(val)
  test         j2rc,  j2MSB8 wz
  if_nz or     j2rc,  j2M1BXT  ' byte extend
  mov          j2t1,  j2rc      ' val
'  fp := jd.getJvmFP
  rdlong       j2rc,  j2fp
'  val += jd.readJavaIntBE(fp + (index<<1))
  shl          j2t0,  #1        ' index<<1
  add          j2rc,  j2t0      ' address to load
  'adds         j2rc,  j2t0      ' address to load ... can't use adds with 16bit JVM
  mov          j2t0,  j2rc      ' j2t0 = fp+(index<<1)
  call         #j2loadWord  
  add          j2rc,  j2t1      ' val += loadword
'  jd.writeJavaIntBE(fp + (index<<1),val)
  mov          j2arg1,j2t0
  call         #j2saveWord
'  jd.incJvmPC(3)
  jmp          #j2incrPC3done

'_____________________________________________________________________________
'
doJem_GETFIELD
'' doJem_GETFIELD Meaning: Fetch 32-bit field from object.
{
  JEM format: getfield,byte1,byte2
  byte1 and byte2 form 16bits offset into object instance on heap: offset = (byte1<<8)|(byte2) 

  aref := js.pop  'get reference ... if it's > hp, sub j2jem
  offset := jd.readJavaIntBE(jd.getJvmPC+1)
  value := jd.readJavaIntBE(aref + offset)
  js.push(value) 'return value
  jd.incJvmPC(3)
}
'' GETFIELD reads from classes or objects. Classes are stored in read-only space < heap.
'' Objects are stored in heap. We have to adjust for class data by j2jem offset.
'' This smells like a huge hack, and would be better if everything was relative to j2jem offset.
''
'  aref := js.pop  'get reference
  call         #j2pop
  rdlong       j2t2,  j2hp  ' get heap
  cmp          j2rc,  j2t2 wz,wc ' if aref >= heap
  if_ae sub    j2rc,  j2jem ' get aref no jem offset
  mov          j2t0,  j2rc  ' j2t0 = aref
'  offset := jd.readJavaIntBE(jd.getJvmPC+1)
  call         #j2loadWordPcPlus1
  add          j2rc,  j2t0  ' offset + aref
'  value := jd.readJavaIntBE(aref + offset)
  call         #j2loadWord
  'if_ae call   #j2swap16                                                                                    
  jmp          #j2pushIncrPC3done

'_____________________________________________________________________________
'
doJem_PUTFIELD
'' doJem_PUTFIELD Meaning: Set 32-bit field in object.
{
  JEM format: putfield,byte1,byte2
  byte1 and byte2 form 16bits offset into object instance on heap: offset = (byte1<<8)|(byte2) 

  value := js.pop 'get value
  aref := js.pop  'get reference
  offset := jd.readJavaIntBE(jd.getJvmPC+1)
  jd.writeJavaIntBE(aref + offset,value)
  jd.incJvmPC(3)
}
'' PUTFIELD only saves to heap, so we can ignore j2jem offset  ??? 
  call         #j2pop
  mov          j2t0,  j2rc  ' j2t0 = value
  call         #j2pop
  sub          j2rc,  j2jem ' get aref no jem offset
  mov          j2t1,  j2rc  ' j2t1 = aref
  call         #j2loadWordPcPlus1
  
  'rdlong       j2t2,  j2hp  ' get heap
  'cmp          j2rc,  j2t2 wz,wc ' if aref >= heap
  'if_b  sub    j2rc,  j2jem ' get aref no jem offset
  'sub          j2rc,  j2jem ' get aref no jem offset
  
  add          j2t1,  j2rc  ' j2t1 = aref + offset
  mov          j2arg1,j2t1  ' aref+offset
  mov          j2rc,  j2t0  ' value
  'if_ae call   #j2swap16
  call         #j2saveWord
  jmp          #j2incrPC3done


'_____________________________________________________________________________
'
doJem_NEW
'' doJem_NEW Meaning: Create new object.
{
  Description: byte1 and byte2 are used to construct an index into the constant pool of the 
  current class, which must be a class name that can be resolved to a class pointer. A new 
  instance of that class is then created, and a reference to the object is pushed on the stack.
 
  JEM format: new,byte1,byte2
  byte1 and byte2 form 16bits offset to class descriptor: class = (byte1<<8)|(byte2) 

  class := jd.readJavaIntBE(jd.getJvmPC+1)
  size := jd.readJavaByte(class + jd#JVM_FIELDS) 'get size of non-static non-final variables
  aref := jh.allocate(size + 2) 'add 2 for class reference
  if aref <> 0
    jd.writeJavaIntBE(aref,class)
    i := 2
    repeat size 'clear databytes
      jd.writeJavaByte(aref+i,$00)
      i++
    js.push(aref) 'push reference to instance
    jd.incJvmPC(3)
  else
    je.throw(je#kOutOfMemoryError)
}
'  class := jd.readJavaIntBE(jd.getJvmPC+1)
  call         #j2loadWordPcPlus1
  mov          j2t0,  j2rc      ' j2t0 = class
'  size := jd.readJavaByte(class + jd#JVM_FIELDS) 'get size of non-static non-final variables
  add          j2rc,  #pcn#JVM_FIELDS
  call         #j2loadByte
  mov          j2t1,  j2rc      ' j2t1 = size
'  aref := jh.allocate(size + 2) 'add 2 for class reference
  add          j2rc,  #2
  mov          j2arg1,j2rc
  call         #j2allocate
  cmp          j2rc,  #0 wz
  if_z  jmp    #memExcptnNEW
'  if aref <> 0
'    jd.writeJavaIntBE(aref,class)
  mov          j2t2,  j2rc      ' j2t2 = aref ... save for later
  sub          j2t2,  j2jem     ' save aref no jem offset
  mov          j2arg1,j2t2
  mov          j2rc,  j2t0      ' j2t0 = class
  call         #j2saveWord
'{
'    i := 2
  sub          j2t1,  #1 wz,wc
  if_be jmp    #clrDone
  add          j2t1,  #1      ' add back so we clear all of new block
  mov          j2t3,  #2      ' index
'    repeat size 'clear databytes j2t1 = size
clrNEW
'      jd.writeJavaByte(aref+i,$00)
  mov          j2arg1,j2t2
  add          j2arg1,j2t3
  mov          j2rc,  #0
  call         #j2saveByte
'      i++
  add          j2t3,  #1
  djnz         j2t1,  #clrNEW
'}
clrDone
'    js.push(aref) 'push reference to instance
  add          j2t2,  j2jem     ' push aref no jem offset
  mov          j2rc,  j2t2
'    jd.incJvmPC(3)
  jmp          #j2pushIncrPC3done
memExcptnNEW
'  else
'    je.throw(je#kOutOfMemoryError)
  rdlong       j2rc,  j2pc
  or           j2rc,  j2EXCPTN
  wrlong       j2rc,  j2cmdp        ' set exception command
  jmp          #jvm2done



'_____________________________________________________________________________
'
{{ doJem_NotUsed Meaning: Handle unused bytecode.
}}
j2doJem_NotUsed
  jmp          #jvm2done


'_____________________________________________________________________________
' special push/pop for dup etc... no endian translation
' j2push1
' input j2arg1
'
j2push1
  rdword       j2tp,  j2sp
  add          j2tp,  j2jem
  wrword       j2arg1,j2tp
  add          j2tp,  #2
  sub          j2tp,  j2jem
  wrword       j2tp,  j2sp
j2push1_ret     ret

'_____________________________________________________________________________
' special push/pop for dup etc... no endian translation
' j2push2
' input j2arg2
'
j2push2
  rdword       j2tp,  j2sp
  add          j2tp,  j2jem
  wrword       j2arg2,j2tp
  add          j2tp,  #2
  sub          j2tp,  j2jem
  wrword       j2tp,  j2sp
j2push2_ret     ret

'_____________________________________________________________________________
' special push/pop for dup etc... no endian translation
' j2push3
' input j2arg3
'
j2push3
  rdword       j2tp,  j2sp
  add          j2tp,  j2jem
  wrword       j2arg3,j2tp
  add          j2tp,  #2
  sub          j2tp,  j2jem
  wrword       j2tp,  j2sp
j2push3_ret     ret

'_____________________________________________________________________________
' special push/pop for dup etc... no endian translation
' j2push4
' input j2arg4
'
j2push4
  rdword       j2tp,  j2sp
  add          j2tp,  j2jem
  wrword       j2arg4,j2tp
  add          j2tp,  #2
  sub          j2tp,  j2jem
  wrword       j2tp,  j2sp
j2push4_ret     ret

'_____________________________________________________________________________
' special push/pop for dup etc... no endian translation
' j2pop1
' ouj2tput j2arg1
'
j2pop1
  rdword       j2tp,  j2sp
  add          j2tp,  j2jem
  sub          j2tp,  #2
  rdword       j2arg1,j2tp
  sub          j2tp,  j2jem
  wrword       j2tp,  j2sp
j2pop1_ret      ret


'_____________________________________________________________________________
' special push/pop for dup etc... no endian translation
' jpop2
' ouj2tput j2arg2
'
j2pop2
  rdword       j2tp,  j2sp
  add          j2tp,  j2jem
  sub          j2tp,  #2
  rdword       j2arg2,j2tp
  sub          j2tp,  j2jem
  wrword       j2tp,  j2sp
j2pop2_ret      ret

'_____________________________________________________________________________
' special push/pop for dup etc... no endian translation
' j2pop3
' ouj2tput j2arg3
'
j2pop3
  rdword       j2tp,  j2sp
  add          j2tp,  j2jem
  sub          j2tp,  #2
  rdword       j2arg3,j2tp
  sub          j2tp,  j2jem
  wrword       j2tp,  j2sp
j2pop3_ret      ret

'_____________________________________________________________________________
' special push/pop for dup etc... no endian translation
' jpop4
' ouj2tput j2arg4
'
j2pop4
  rdword       j2tp,  j2sp
  add          j2tp,  j2jem
  sub          j2tp,  #2
  rdword       j2arg4,j2tp
  sub          j2tp,  j2jem
  wrword       j2tp,  j2sp
j2pop4_ret      ret

'_____________________________________________________________________________
'
' jpush
' long  j2rc
'
j2push
  rdword       j2tp,  j2sp
  add          j2tp,  j2jem
  call         #j2swap16  
  wrword       j2rc,  j2tp
  add          j2tp,  #2
  sub          j2tp,  j2jem
  wrword       j2tp,  j2sp
  call         #j2swap16
j2push_ret      ret

'_____________________________________________________________________________
'
' jpop
' long  j2rc
'
j2pop
  rdword       j2tp,  j2sp
  add          j2tp,  j2jem
  sub          j2tp,  #2
  rdword       j2rc,  j2tp
  call         #j2swap16  
  sub          j2tp,  j2jem
  wrword       j2tp,  j2sp
j2pop_ret       ret

'_____________________________________________________________________________
'
' jpop
' long  j2rc
'
j2poparg12
  rdword       j2tp,  j2sp
  add          j2tp,  j2jem
  sub          j2tp,  #2
  rdword       j2rc,  j2tp
  call         #j2swap16  
  mov          j2arg1,j2rc
  sub          j2tp,  #2
  rdword       j2rc,j2tp
  call         #j2swap16  
  mov          j2arg2,j2rc
  sub          j2tp,  j2jem
  wrword       j2tp,  j2sp
j2poparg12_ret ret

'_____________________________________________________________________________
'
' swap16
' long  j2rc
j2swap16
  and          j2rc,j2Minus1    ' prevent overflow  
  mov          j2arg4,j2rc
  and          j2rc,  #$ff
  shr          j2arg4,#8
  shl          j2rc,  #8
  or           j2rc, j2arg4
j2swap16_ret     ret

'_____________________________________________________________________________
'
' j2setWord16
' long  j2rc
j2setWord16
  and          j2arg1, j2MINUS1
  shl          j2arg1, #8
  or           j2arg1, j2arg2
  mov          j2rc,   j2arg1
j2setWord16_ret  ret

'_____________________________________________________________________________
'
' j2loadBytePcPlus1
' long  j2rc
'
j2loadBytePcPlus1
  rdlong       j2rc,  j2pc
  add          j2rc,  j2jem
  add          j2rc,  #1   ' add pc+1
  rdbyte       j2rc,  j2rc   ' read byte at pc+1
j2loadBytePcPlus1_ret      ret

'_____________________________________________________________________________
'
' j2loadWordPcPlus1
' long  j2rc
'
j2loadWordPcPlus1
  rdlong       j2rc,  j2pc
  add          j2rc,  j2jem
  add          j2rc,  #1   ' add pc+1
  rdbyte       j2arg1,j2rc   ' read byte
  add          j2rc,  #1
  rdbyte       j2arg2,j2rc   ' read byte
  call         #j2setWord16
j2loadWordPcPlus1_ret      ret

'_____________________________________________________________________________
'
' loadByte
' long  j2rc
'
j2loadByte
  add          j2rc,  j2jem
  rdbyte       j2rc,  j2rc   ' read byte at pc+1
j2loadByte_ret   ret

'_____________________________________________________________________________
'
' loadWord
' long  j2rc
'
j2loadWord
  add          j2rc,  j2jem
  rdbyte       j2arg1,j2rc   ' read byte
  add          j2rc,  #1
  rdbyte       j2arg2,j2rc   ' read byte
  call         #j2setWord16
j2loadWord_ret   ret

'_____________________________________________________________________________
'
' saveByte
' long  j2arg1 = address
' long  j2rc = data
'
j2saveByte
  mov          j2tp,  j2arg1 ' get bytecode base
  add          j2tp,  j2jem
  wrbyte       j2rc,  j2tp ' write byte
j2saveByte_ret   ret

'_____________________________________________________________________________
'
' saveWord
' long  j2arg1 = address
' long  j2rc = data
'
j2saveWord
  mov          j2tp,  j2arg1 ' get bytecode base
  add          j2tp,  j2jem
  add          j2tp,  #1
  wrbyte       j2rc,  j2tp   ' write word
  shr          j2rc,  #8
  sub          j2tp,  #1
  wrbyte       j2rc,  j2tp   ' write word
j2saveWord_ret   ret

'_____________________________________________________________________________
'
' call  #j2pop2signed
' long  j2arg1
' long  j2arg2
j2pop2signed
  call         #j2pop
  call         #j2signExtend16
  mov          j2arg1,j2rc          ' w1
  call         #j2pop
  call         #j2signExtend16
  mov          j2arg2,j2rc          ' w2
j2pop2signed_ret ret

'_____________________________________________________________________________
'
' call  #j2signExtend16
' long  j2rc
j2signExtend16
  test         j2rc,  j2MSB16 wz
  if_nz or     j2rc,  j2M1WDXT
j2signExtend16_ret   ret

{
'_____________________________________________________________________________
'
j2clrCarry
  'mov          j2rc,  #1        ' inverted ????
  wrlong       j2zero,  j2cp
j2clrCarry_ret   ret

'_____________________________________________________________________________
'
j2setCarry
  'mov          j2rc,  #0
  wrlong       j2one,  j2cp
j2setCarry_ret   ret
}

'_____________________________________________________________________________
'
j2incrPC
  rdlong       j2rc,  j2pc
  add          j2rc,  #1
  wrlong       j2rc,  j2pc
j2incrPC_ret     ret

'_____________________________________________________________________________
'
j2pushIncrPCdone
  call         #j2push
j2incrPCdone
  rdlong       j2rc,  j2pc
  add          j2rc,  #1
  wrlong       j2rc,  j2pc
  jmp          #jvm2done

'_____________________________________________________________________________
'
j2pushIncrPC2done
  call         #j2push
j2incrPC2
  call         #j2incrPC
  call         #j2incrPC
j2incrPC2_ret    ret

'_____________________________________________________________________________
'
j2pushIncrPC3done
  call         #j2push
j2incrPC3done
  rdlong       j2rc,  j2pc
  add          j2rc,  #3
  wrlong       j2rc,  j2pc
  jmp          #jvm2done
j2incrPC3_ret    ret

'_____________________________________________________________________________
'
{ used only in GOTO
j2addPC
  call         #j2signExtend16
  rdlong       j2tp, j2pc
  add          j2tp, j2rc
  wrlong       j2tp, j2pc
j2addPC_ret      ret
}

'_____________________________________________________________________________
'
' alloc
' @parm j2arg1  number of bytes
' @return j2rc  new pointer
'
{ save for unmanaged heap allocation
j2allocate
  rdlong       j2rc,  j2hp
  rdlong       j2pp,  j2sp
  cmp          j2rc,  j2pp wc
  if_c  mov    j2rc,  #0
  if_nc rdlong j2rc,  j2hp
  if_nc sub    j2rc,  j2arg1
'  if_nc andn   j2rc,  #1        ' even bytes
  if_nc wrlong j2rc,  j2hp      ' get pointer
j2allocate_ret   ret
'}
'{
j2allocate
'{
  rdlong      j2rc,  j2hp
  rdlong      j2pp,  j2sp
  cmp         j2rc,  j2pp wc
  if_c  mov   j2rc,  #0
  if_c  jmp   #j2allocate_ret
'}
  mov         j2rc, j2MALLOC    ' handler does alloc if MALLOC_BIT set
  or          j2rc, j2arg1      ' request j3arg1 bytes
  wrlong      j2rc, j2ctrp      ' write alloc request
  rdlong      j2rc, j2ctrp      ' wait for request complete
  cmps        j2rc, #0  wc      ' wait until D < S
  if_nc       jmp   #$-2        ' if D > S wait for request complete
  rdlong      j2rc, j2ap        ' get reference
j2allocate_ret ret
'}

'_____________________________________________________________________________
'
' support constants
'
j2MINUS1  long   $FFFF    ' 16 bit machine
j2NEG132  long   -1
j2MSB8    long   $80
j2M1BXT   long   $FF00
j2MSB16   long   $8000
j2M1WDXT  long   $FFFF0000
j2M1WDXTM long   $FFFF8000
j2EXCPTN  long   EXCPTN_BIT
j2MALLOC  long   MALLOC_BIT
j2zero    long   0
j2one     long   1

'_____________________________________________________________________________
'
' call variables
'
j2arg1    long 0
j2arg2    long 0
j2arg3    long 0
j2arg4    long 0
j2rc      long 0

'_____________________________________________________________________________
'
' local variables
'
j2pp      long 0    ' special pointer var for get/set fp,mp,sp,etc....
j2tp      long 0
j2t0      long 0
j2t1      long 0
j2t2      long 0
j2t3      long 0

'_____________________________________________________________________________
'
' spin command interface
'
j2cmdp    long 0    ' shared jvm instruction pointer
j2ctrp    long 0    ' control pointer 0 if nothing to do
j2jemp    long 0    ' not a rdlong pointer

'_____________________________________________________________________________
'
' jvm  variables
'
j2pc      long 0    ' program counter pointer
j2bp      long 0    ' stack base pointer
j2sp      long 0    ' stack pointer
j2fp      long 0    ' frame pointer
j2mp      long 0    ' method pointer
j2ap      long 0    ' allocated heap pointer
j2hp      long 0    ' heap end pointer
j2ep      long 0    ' exception pointer
j2cp      long 0    ' carry pointer
j2sbp     long 0    ' static base pointer
j2strp    long 0    ' strings pointer
j2tap1    long 0    ' jump table pointer1
j2tap2    long 0    ' jump table pointer2
j2tap3    long 0    ' jump table pointer3

j2jem     long 0    ' jem base

  fit   $1f0
'_____________________________________________________________________________
'
'}
'{
dat     '' pasm implementing jvm
        ' can also do exception handling here?

jvm3           org 0
long    0 [8]  ' for debugger
  
  mov          j3tp,  par

  mov          j3t1,  #j3cmdp
  mov          j3t0,  #pcn#JVM_ENG_NOOFPARMS         ' noof parameters
j3ploop
  movd  j3pwrite,j3t1
  add   j3t1,    #1
j3pwrite  mov    0-0, j3tp
  add          j3tp, #4
  djnz         j3t0,  #j3ploop

jvm3loop
  rdlong       j3rc,  j3ctrp wz
  if_z  jmp    #jvm3loop
  rdlong       j3jem, j3jemp            ' get jem offset

  rdlong       j3rc,  j3cmdp
  cmp          j3rc,  #pcn#Jem_NEWARRAY wz,wc    ' 0 is a valid opcode
  if_b  jmp    #jvm3loop
  cmp          j3rc,  #pcn#Jem_LOOKUPSWITCH wz,wc
  if_a  jmp    #jvm3loop
  
  rdlong       j3tp,  j3tap3        ' get table base address
  sub          j3rc,  #pcn#Jem_NEWARRAY   
  shl          j3rc,  #1
  add          j3tp,  j3rc          ' get tap[j3rc] address
  rdword       j3t0,  j3tp          ' get tap[j3rc] value
  movs         j3jmpit,j3t0         ' set routine address
  nop  
j3jmpit  jmp    #0-0             ' jmp bytecode routine

jvm3done
  mov          j3rc, #0
  wrlong       j3rc, j3ctrp       
  jmp   #jvm3loop


'_____________________________________________________________________________
'
doJem_NEWARRAY
'' doJem_NEWARRAY Meaning: j3allocate new array.
{
  Description: A new array of a specific array type, capable of holding size elements, is allocated. The result
  is a reference to the new object. Allocation of an array large enough to contain size items of the specific
  array type is attempted and all elements of the array are initialized to 0.  
  size represents the number of elements in the new array and must be an integer. The result is stored with an
  internal code that indicates the type of array to j3allocate. Possible values for the type of array are as follows:
  T_BOOLEAN 4, T_CHAR 5, T_FLOAT 6, T_DOUBLE 7, T_BYTE 8, T_SHORT 9, T_INT 10, T_LONG 11
  Note:
  A NegativeArraySizeException is thrown if size is less than 0. 
  An OutOfMemoryError is thrown if there is not enough memory to j3allocate the array.
 
  j3jem format: newarray,byte1
  byte1 identifies type: 0 for short and int, 1 for boolean, byte and char. 

  len := js.pop 'pop length
  if len > 0
    type := jd.readJavaByte(jd.getJvmPC+1)
    size := len*(2-type)
    aref := jh.j3allocate(size + 4)
    if aref <> 0
      class := jd.readJavaIntBE(jd#JVM_OBJECT)
      jd.writeJavaIntBE(aref+0,class)
      jd.writeJavaIntBE(aref+2,len)
      i := 4
      repeat size 'clear array
        jd.writeJavaByte(aref+i,$00)
        i++
      js.push(aref) 'push reference
      jd.incJvmPC(2)
    else
      je.throw(je#kOutOfMemoryError)
  else
    je.throw(je#kIllegalArgumentException)
}
  call         #j3pop
  cmp          j3rc,  #0 wz,wc
  if_be jmp    #argExcptnNEWARRAY
  mov          j3t0,  j3rc      ' j3t0 = len
  call         #j3loadBytePcPlus1
  mov          j3t1,  j3rc      ' j3t1 = type
  mov          j3t2,  #2
  sub          j3t2,  j3t1
  mov          j3arg1,j3t0
  mov          j3arg2,j3t2
  call         #j3multiply
  mov          j3t1,  j3rc      ' j3t1 = size
  add          j3rc,  #4
  mov          j3arg1,j3rc
  call         #j3allocate      ' clear new array further down
  mov          j3t2,  j3rc      ' j3t2 = aref
  sub          j3t2,  j3jem     ' get aref no jem offset
  cmp          j3rc,  #0 wz
  if_z  jmp    #memExcptnNEWARRAY
  mov          j3rc,  #pcn#JVM_OBJECT
  call         #j3loadWord
  mov          j3t3,  j3rc      ' j3t3 = class
  mov          j3arg1, j3t2
  mov          j3rc, j3t3               
  call         #j3saveWord  
  add          j3arg1, #2
  mov          j3rc, j3t0
  call         #j3saveWord
  mov          j3t4,  #4      ' j3t4 = index
clrNEWARRAY
  mov          j3arg1,j3t2
  add          j3arg1,j3t4      ' j3arg1 = aref+index
  mov          j3rc,  #0
  call         #j3saveByte
  add          j3t4,  #1
  djnz         j3t1,  #clrNEWARRAY
  add          j3t2,  j3jem     ' add back jem offset for aref on stack
  mov          j3rc,  j3t2      ' j3t2 = aref
  jmp          #j3pushIncrPC2done
memExcptnNEWARRAY
  mov          j3t0, j3x4000
argExcptnNEWARRAY      
  jmp          #j3exception
  
'_____________________________________________________________________________
'
doJem_ANEWARRAY
'' doJem_ANEWARRAY Meaning: j3allocate new array of objects.
{
  Description: A new array of the indicated class type and capable of holding size elements is allocated.
  The result is a reference to the new object. Allocation of an array large enough to contain size elements
  of the given class type is attempted and all elements of the array are initialized to null.  
  size represents the number of elements in the new array and must be an integer. byte1 and byte2
  are used to construct an index into the constant pool of the current class. When the item at that index
  is resolved, the resulting entry must be a class. 
  Note:
  A NegativeArraySizeException is thrown if size is less than 0. 
  An OutOfMemoryError is thrown if there is not enough memory to j3allocate the array.  

  The anewarray instruction is used to create a single-dimension array. For example, the declaration
  new Thread[7] generates the following bytecode instructions:  
    bipush 7 
    anewarray <Class "java.lang.Thread">
  The anewarray instruction can also be used to create the outermost dimension of a multidimensional array. 
  for example, the array declaration new int[6][] generates the following bytecode instructions:  
    bipush 6 
    anewarray <Class "[I">
 
  j3jem format: anewarray,byte1,byte2
  byte1 is always 0. byte2 identifies type: 0 for short, int and reference, 1 for boolean, byte and char.
  Since array of objects equals array of references, byte2 is always 0 too. 

  len := js.pop 'pop length
  if len > 0
    type := jd.readJavaByte(jd.getJvmPC+2)
    size := len*(2-type)
    aref := jh.j3allocate(size + 4)
    if aref <> 0
      class := jd.readJavaIntBE(jd#JVM_OBJECT)
      jd.writeJavaIntBE(aref+0,class)
      jd.writeJavaIntBE(aref+2,len)
      i := 4
      repeat size 'clear array
        jd.writeJavaByte(aref+i,$00)
        i++
      js.push(aref) 'push reference
      jd.incJvmPC(3)
    else
      je.throw(je#kOutOfMemoryError)
  else
    je.throw(je#kIllegalArgumentException)
}
  call         #j3pop
  cmp          j3rc,  #0 wz,wc
  if_be jmp    #argExcptnANEWARRAY
  mov          j3t0,  j3rc      ' j3t0 = len
  rdlong       j3rc,  j3pc
  add          j3rc,  #2      ' only diff between this and NEWARRAY?
  call         #j3loadByte
  mov          j3t1,  j3rc      ' j3t1 = type
  mov          j3t2,  #2
  sub          j3t2,  j3t1
  mov          j3arg1,j3t0
  mov          j3arg2,j3t2
  call         #j3multiply
  mov          j3t1,  j3rc      ' j3t1 = size
  add          j3rc,  #4
  mov          j3arg1,j3rc
  call         #j3allocate
  mov          j3t2,  j3rc      ' j3t2 = aref
  sub          j3t2,  j3jem     ' get aref no jem offset
  cmp          j3rc,  #0 wz
  if_z  jmp    #memExcptnANEWARRAY
  mov          j3rc,  #pcn#JVM_OBJECT
  call         #j3loadWord
  mov          j3t3,  j3rc      ' j3t3 = class
  mov          j3arg1, j3t2
  mov          j3rc, j3t3
  call         #j3saveWord  
  add          j3arg1, #2
  mov          j3rc, j3t0
  call         #j3saveWord
  mov          j3t4,  #4      ' j3t4 = index
clrANEWARRAY
  mov          j3arg1,j3t2
  add          j3arg1,j3t4      ' j3arg1 = aref+index
  mov          j3rc,  #0
  call         #j3saveByte
  add          j3t4,  #1
  djnz         j3t1,  #clrANEWARRAY
  add          j3t2,  j3jem     ' add back jem offset for aref on stack
  mov          j3rc,  j3t2
  jmp          #j3pushIncrPC3done
memExcptnANEWARRAY
  mov          j3t0, j3x4000
argExcptnANEWARRAY      
  jmp          #j3exception


'_____________________________________________________________________________
'
doJem_IALOAD
'' doJem_IALOAD Meaning: Load integer from array.
{
  Description: The integer value at the array aref is retrieved and pushed onto the top of the stack.
  The index must be a reference to an array of integers; likewise, the index into the array must be an integer. 
  Note:
  A NullPointerException is thrown if aref is null. An ArrayIndexOutOfBoundsException is thrown if the array index
  is not within the bounds of the array.
 
  j3jem format: iaload

  index := js.pop 'get index
  aref := js.pop  'get reference
  if aref <> 0
    elements := jd.readJavaIntBE(aref + 2)
    if index => 0 AND index < elements
      val := jd.readJavaIntBE(aref + 4 + (index<<1))
      js.push(val)    'push value
      jd.incJvmPC(1)
    else
      je.throw(je#kIndexOutOfBoundsException)
  else
    je.throw(je#kNullPointerException)
}
  call         #j3pop
  mov          j3t0,  j3rc      ' j3t0 = index
  call         #j3pop
  'mov          j3t1,  j3rc      ' j3t1 = aref
  cmp          j3rc,  #0  wz
  if_z  jmp    #nullExcptnIALOAD
  
  rdlong       j3t2,  j3hp  ' get heap
  cmp          j3rc,  j3t2 wz,wc ' if aref >= heap
  if_ae sub    j3rc,  j3jem ' get aref no jem offset
  mov          j3t1,  j3rc      ' j3t1 = aref

  add          j3rc,  #2        ' aref + 2
  'mov          j3t2,  j3rc      ' j3t2 = aref
  
  call         #j3loadWord
  mov          j3t2,  j3rc      ' j3t2 = elements
  cmp          j3t0,  #0 wz,wc
  if_b  jmp    #oobExcptnIALOAD ' if index < 0 throw OOB
  cmp          j3t0,  j3t2 wz,wc
  if_ae jmp    #oobExcptnIALOAD ' if index >= elements throw OOB
  
  mov          j3rc, j3t1       ' rc = aref
  add          j3rc, #4         ' rc = aref + 4
  shl          j3t0, #1         ' index << 1
  add          j3rc,  j3t0      ' rc = aref + 4 + index << 1
  call         #j3loadWord
  call         #j3swap16
  
  jmp          #j3pushIncrPCdone
oobExcptnIALOAD  
  mov          j3t0, j3x4000
nullExcptnIALOAD
  jmp          #j3exception

'_____________________________________________________________________________
'
doJem_IASTORE
'' doJem_IASTORE Meaning: Store into integer array.
{
  Description: An integer value is popped off the stack and stored in the array at the index. The aref must be
  a reference to an array of integer values, and the index into the array must be an integer as well.
 
  j3jem format: iastore

  val := js.pop   'get value
  index := js.pop 'get index
  aref := js.pop  'get reference
  if aref <> 0
    elements := jd.readJavaIntBE(aref + 2)
    if index => 0 AND index < elements
      jd.writeJavaIntBE(aref + 4 + (index<<1),val)
      jd.incJvmPC(1)
    else
      je.throw(je#kIndexOutOfBoundsException)
  else
    je.throw(je#kNullPointerException)
}
'  val := js.pop   'get value
  call         #j3pop
  mov          j3t3,  j3rc      ' j3t3 = value
'  index := js.pop 'get index
  call         #j3pop
  mov          j3t0,  j3rc      ' j3t0 = index
'  aref := js.pop  'get reference
  call         #j3pop

  rdlong       j3t2,  j3hp  ' get heap
  cmp          j3rc,  j3t2 wz,wc ' if aref >= heap
  if_ae sub    j3rc,  j3jem ' get aref no jem offset

  mov          j3t1,  j3rc      ' j3t1 = aref
'  if aref == 0  exception
  cmp          j3rc,  #0  wz
  if_z  jmp    #nullExcptnIASTORE
'  if aref <> 0
'    elements := jd.readJavaIntBE(aref + 2)
  add          j3rc,  #2
  call         #j3loadWord
  mov          j3t2,  j3rc      ' j3t2 = elements

  cmp          j3t0,  #0 wz,wc
  if_b  jmp    #oobExcptnIASTORE
  cmp          j3t0,  j3t2 wz,wc
  if_ae jmp    #oobExcptnIASTORE
'    if index => 0 AND index < elements
'      jd.writeJavaIntBE(aref + 4 + (index<<1),val)
  mov          j3arg1,j3t1
  add          j3arg1,#4
  shl          j3t0,  #1
  add          j3arg1,j3t0
  mov          j3rc,  j3t3
  call         #j3swap16
  call         #j3saveWord
'      jd.incJvmPC(1)
  jmp          #j3incrPCdone
'    else
'      je.throw(je#kIndexOutOfBoundsException)
oobExcptnIASTORE  
  mov          j3t0, j3x4000
'  if aref == 0  exception
'    je.throw(je#kNullPointerException)
nullExcptnIASTORE
  jmp          #j3exception


'_____________________________________________________________________________
'
doJem_BALOAD
'' doJem_BALOAD Meaning: Load signed byte from array.
{
  Description: The signed byte value at the array index is retrieved, expanded to an integer, and pushed onto
  the top of the stack. The aref must be a reference to an array of signed byte values, and the index into the
  array must be an integer.
 
  j3jem format: baload

  index := js.pop 'get index
  aref := js.pop  'get reference
  if aref <> 0
    elements := jd.readJavaIntBE(aref + 2)
    if index => 0 AND index < elements
      val := jd.readJavaByte(aref + 4 + index)
      js.push(val)    'push value
      jd.incJvmPC(1)
    else
      je.throw(je#kIndexOutOfBoundsException)
  else
    je.throw(je#kNullPointerException)
}
'  index := js.pop 'get index
  call         #j3pop
  mov          j3t0,  j3rc      ' j3t0 = index
'  aref := js.pop  'get reference
  call         #j3pop

  rdlong       j3t2,  j3hp  ' get heap
  cmp          j3rc,  j3t2 wz,wc ' if aref >= heap
  if_ae sub    j3rc,  j3jem ' get aref no jem offset

  mov          j3t1,  j3rc      ' j3t1 = aref
' aref == 0 ?
  cmp          j3rc,  #0  wz
  if_z  jmp    #nullExcptnBALOAD
'  if aref <> 0
'    elements := jd.readJavaIntBE(aref + 2)
  add          j3rc,  #2
  call         #j3loadWord
  mov          j3t2,  j3rc      ' j3t2 = elements
'    if index => 0 AND index < elements
  cmp          j3t0,  #0 wz,wc
  if_b  jmp    #oobExcptnBALOAD
  cmp          j3t0,  j3t2 wz,wc
  if_ae jmp    #oobExcptnBALOAD
'      val := jd.readJavaByte(aref + 4 + index)
  mov          j3rc, j3t1
  add          j3rc, #4
  add          j3rc, j3t0
  call         #j3loadByte
'      js.push(val)    'push value
'      jd.incJvmPC(1)
  jmp          #j3pushIncrPCdone
'    else
'      je.throw(je#kIndexOutOfBoundsException)
oobExcptnBALOAD
  mov          j3t0, j3x4000  
'  else
'    je.throw(je#kNullPointerException)
nullExcptnBALOAD
  jmp          #j3exception

'_____________________________________________________________________________
'
doJem_BASTORE
'' doJem_BASTORE Meaning: Store into signed byte array.
{
  Description: An integer is popped off the stack, converted to a signed byte, and stored in the array at the index.
  The aref must be a reference to an array of signed bytes, and the index into the array must be an integer.
  If the integer value is too large to be a signed byte, it is truncated.
 
  j3jem format: bastore

  val := js.pop   'get value
  index := js.pop 'get index
  aref := js.pop  'get reference
  if aref <> 0
    elements := jd.readJavaIntBE(aref + 2)
    if index => 0 AND index < elements
      jd.writeJavaByte(aref + 4 + index,val)
      jd.incJvmPC(1)
    else
      je.throw(je#kIndexOutOfBoundsException)
  else
    je.throw(je#kNullPointerException)
}
'  val := js.pop   'get value
  call         #j3pop
  mov          j3t3,  j3rc      ' j3t3 = value
'  index := js.pop 'get index
  call         #j3pop
  mov          j3t0,  j3rc      ' j3t0 = index
'  aref := js.pop  'get reference
  call         #j3pop

  rdlong       j3t2,  j3hp  ' get heap
  cmp          j3rc,  j3t2 wz,wc ' if aref >= heap
  if_ae sub    j3rc,  j3jem ' get aref no jem offset

  mov          j3t1,  j3rc      ' j3t1 = aref
  cmp          j3rc,  #0  wz    ' j3rc = aref
  if_z  jmp    #nullExcptnBASTORE
'  if aref <> 0
'    elements := jd.readJavaIntBE(aref + 2)
  add          j3rc,  #2        ' j3rc = aref + 2
  call         #j3loadWord
  mov          j3t2,  j3rc      ' j3t2 = elements
'    if index => 0 AND index < elements
  cmp          j3t0,  #0 wz,wc
  if_b  jmp    #oobExcptnBASTORE
  cmp          j3t0,  j3t2 wz,wc
  if_ae jmp    #oobExcptnBASTORE
'      jd.writeJavaByte(aref + 4 + index,val)
  mov          j3arg1,j3t1
  add          j3arg1,#4
  add          j3arg1,j3t0
  mov          j3rc,  j3t3
  call         #j3saveByte
'      jd.incJvmPC(1)
  jmp          #j3IncrPCdone
'    else
'      je.throw(je#kIndexOutOfBoundsException)
oobExcptnBASTORE  
  mov          j3t0, j3x4000
'  else
'    je.throw(je#kNullPointerException)
nullExcptnBASTORE
  jmp          #j3exception
  
'_____________________________________________________________________________
'
doJem_LDC
'' doJem_LDC Meaning: Push item from constant pool.
{
  j3jem format: ldc,byte1
  byte1 is index in String Indextable

  index := jd.readJavaByte(jd.getJvmPC+1)
  val := jd.getLdc(index)
  js.push(val) 
  jd.incJvmPC(2)
}
  call         #j3loadBytePcPlus1
  call         #j3loadConst   ' j3rc = index
  jmp          #j3pushIncrPC2done

'_____________________________________________________________________________
'
doJem_LDC_W
'' Meaning: Push 2-byte item from constant pool.
{
  j3jem format: ldc_w,byte1,byte2
  byte1 is always 0. byte2 is index in String Indextable

  index := jd.readJavaByte(jd.getJvmPC+2)
  val := jd.getLdc(index)
  js.push(val) 
  jd.incJvmPC(3)
}
  rdlong       j3rc,  j3pc
  add          j3rc,  #2
  call         #j3loadByte
  call         #j3loadConst
  jmp          #j3pushIncrPC3done
  
'_____________________________________________________________________________
'
doJem_LDC2_W            ' not used ... table just says jump

'_____________________________________________________________________________
'
doJem_IMUL
'' doJem_IMUL Meaning: Integer j3multiply.
{
  j3jem format: imul

  w2 := js.pop
  w2 := ~~w2 'sign extend b15
  w1 := js.pop
  w1 := ~~w1 'sign extend b15
  w1 := w1 * w2
  jd.clearCarry
  if w1 < -32768 OR w1 > 32767
    jd.j3setCarry
  js.push(w1)
  jd.incJvmPC(1)
}
  call        #j3pop2signed
  call        #j3multiply
  mov         j3arg1,   j3rc
  call        #j3signResult
  jmp         #j3pushIncrPCdone

'_____________________________________________________________________________
'
doJem_IREM
'' doJem_IREM Meaning: Integer remainder.
{
  j3jem format: irem

  w2 := js.pop
  w2 := ~~w2 'sign extend b15
  w1 := js.pop
  w1 := ~~w1 'sign extend b15
  if w2 <> 0
    w1 := w1 // w2
    jd.clearCarry
    if w1 < -32768 OR w1 > 32767
      jd.j3setCarry
    js.push(w1)
    jd.incJvmPC(1)
}
  call        #j3pop2signed
  cmp         j3arg1, #0 wz
  if_z  jmp   #j3exception
  'if_z  jmp   #j3pushIncrPCdone ' just get out if divisor is zero

  call        #j3divide         ' mod result in arg2
  mov         j3arg1,   j3arg2
  'call        #j3signResult     ' result should be in j3arg1
  mov         j3rc, j3arg1
  jmp         #j3pushIncrPCdone

'_____________________________________________________________________________
'
doJem_IDIV
'' doJem_IDIV Meaning: Integer divide.
{
  j3jem format: idiv

  w2 := js.pop
  w2 := ~~w2 'sign extend b15
  w1 := js.pop
  w1 := ~~w1 'sign extend b15
  if w2 <> 0
    w1 := w1 / w2
    jd.clearCarry
    if w1 < -32768 OR w1 > 32767
      jd.j3setCarry
    js.push(w1)
    jd.incJvmPC(1)
}
  call        #j3pop2signed
  cmp         j3arg1, #0 wz
  if_z  jmp   #j3exception
                          
  call        #j3divide         ' div result in arg1
  call        #j3signResult
  jmp         #j3pushIncrPCdone

'_____________________________________________________________________________
'
doJem_JSR
'' doJem_JSR Meaning: Jump subroutine.
{
  Description: Execution proceeds at the signed 16-bit offset from the address of this instruction.
  The offset is constructed from byte1 and byte2. The address of the instruction immediately following
  the current instruction is pushed onto the stack to provide a return address from the subroutine.
  The jsr instruction is used with the ret instruction in the implementation of the finally clauses of the
  Java programming language. Note that jsr pushes the address onto the operand stack and ret gets it out
  of a local variable. This asymmetry is intentional.

  j3jem format: jsr,byte1,byte2

  offset := jd.readJavaIntBE(jd.getJvmPC+1)
  js.push(jd.getJvmPC+3)
  jd.setJvmPC(jd.getJvmPC + offset)
}
  rdlong       j3rc,  j3pc
  mov          j3t0,  j3rc
  add          j3rc,  #3
  call         #j3push
  call         #j3loadWordPcPlus1
  add          j3t0,  j3rc
  wrlong       j3t0,  j3pc
  jmp          #jvm3done

'_____________________________________________________________________________
'
doJem_RET
'' doJem_RET Meaning: Return from subroutine.
{
  Description: Local variable in the current Java frame must contain a return address.
  The contents of the local variable are written into the program counter.
  The ret instruction is used with jsr or jsr_w instructions in the implementation of the finally clauses of the
  Java programming language. Note that jsr pushes the address onto the operand stack and ret gets it out of a
  local variable. This asymmetry is intentional. The ret instruction should not be confused with the return
  instruction. A return instruction returns control from a method to its invoker, without passing any value back
  to the invoker. The ret opcode can be used in conjunction with the wide instruction to access a local variable
  using a two-byte unsigned index.
 
  j3jem format: ret,byte1

  index := jd.readJavaByte(jd.getJvmPC+1)
  retaddr := jd.readJavaIntBE(jd.getJvmFP + (index<<1))
  jd.setJvmPC(retaddr)
}
  call         #j3loadBytePcPlus1
  shl          j3rc,  #1           ' j3rc = index
  rdlong       j3t0,  j3fp         ' j3t0 = j3fp
  add          j3t0,  j3rc
  call         #j3loadWord         ' load ret address
  wrlong       j3rc,  j3pc         ' save ret address
  jmp          #jvm3done

'_____________________________________________________________________________
'
doJem_TABLESWITCH
'' doJem_TABLESWITCH Meaning: Access jump table by index and jump.
{
  Description: Immediately after the tableswitch instruction, padding consisting of 0-3 zeros 
  is inserted so that the next byte begins at an address that is a multiple of four. A series of 
  offsets follows the padding. These offsets are signed 4-byte quantities and consist of a default 
  offset, a low offset, and a high offset, followed by additional <high-low+1> offsets. These 
  additional offsets are treated as a 0-based jump table.  

  The index the offsets point to must be an integer. If the index is less than the low offset or 
  greater than the high offset, the default offset is added to the address of the current 
  instruction. Otherwise, the low offset is subtracted from the index, and the element at the 
  position index - low offset in the jump table is extracted and added to the address of the 
  current instruction.

  j3jem format: tableswitch,byte1,byte2,byte3,byte4,byte5,byte6,<number of offsets>
  default offset = (byte1<<8)|(byte2). Low value = (byte3<<8)|(byte4). High value - low value = (byte5<<8)|(byte6).

  default := jd.readJavaIntBE(jd.getJvmPC+1)
  low := jd.readJavaIntBE(jd.getJvmPC+3)
  high := jd.readJavaIntBE(jd.getJvmPC+5) + low
  index := js.pop 'get index
  if index < low OR index > high
    jd.incJvmPC(default+1)
  else
    index -= low
    offset := jd.readJavaIntBE(jd.getJvmPC + 7 + (index<<1))
    jd.incJvmPC(offset+1)
}
  call         #j3loadWordPcPlus1
  mov          j3t0,  j3rc      ' j3t0 = default
  
  rdlong       j3rc,  j3pc
  add          j3rc,  #3
  call         #j3loadWord
  mov          j3t1,  j3rc      ' j3t1 = low

  rdlong       j3rc,  j3pc
  add          j3rc,  #5
  call         #j3loadWord
  add          j3rc,  j3t1      ' add low
  mov          j3t2,  j3rc      ' j3t2 = high

  call         #j3pop
  mov          j3t3,  j3rc      ' j3t3 = index

  cmp          j3t3,  j3t1  wz,wc
  if_b  jmp    #skipTABLESWITCH ' if index < low, exit
  cmp          j3t3,  j3t2  wz,wc
  if_a  jmp    #skipTABLESWITCH ' if index > high, exit

' index is in bounds; do work
  sub          j3t3,  j3t1      ' index -= low
  shl          j3t3,  #1        ' index <<= 1
  rdlong       j3rc,  j3pc      ' rc = pc
  add          j3rc,  #7        ' rc = pc + 7
  add          j3rc,  j3t3      ' rc = pc + 7 + index << 1
  call         #j3loadWord      ' offset = loadword(pc + 7 + index << 1)
  
  add          j3rc,  #1
  jmp          #j3addPCDone

skipTABLESWITCH  
' index is out of bounds
  add          j3t0,  #1
  mov          j3rc,  j3t0
'  jmp          #j3exception
  jmp          #j3addPCDone

'_____________________________________________________________________________
'
doJem_LOOKUPSWITCH
'' doJem_LOOKUPSWITCH Meaning: Access jump table by key match and jump.
{
  Description: Immediately after the lookupswitch instruction, padding consisting of 0-3 
  zeros is inserted so that the next byte begins at an address that is a multiple of four. A series 
  of pairs of offsets follows the padding. These offsets are signed 4-byte quantities. The first 
  item in the pair is the default offset, and the second item in the pair gives the number of pairs 
  that follow. The additional pairs consist of a match and an offset.  

  The integer key on the stack is then compared against each of the matches. If the key is equal 
  to one of the matches, the offset is added to the address of the current instruction. If the key  
  does not match any of the matches, the default offset is added to the address of the current instruction.
 
  j3jem format: lookupswitch,byte1,byte2,byte3,byte4,<number of pairs: match,offset>
  default offset = (byte1<<8)|(byte2). Number of pairs = (byte3<<8)|(byte4).

  default := jd.readJavaIntBE(jd.getJvmPC+1)
  npairs := jd.readJavaIntBE(jd.getJvmPC+3)
  key := js.pop 'get key
  index := 5
  repeat npairs
    match := jd.readJavaIntBE(jd.getJvmPC + index)
    offset := jd.readJavaIntBE(jd.getJvmPC + index + 2)
    if key == match
      jd.incJvmPC(offset+1)
      return
    index += 4
  jd.incJvmPC(default+1)
}
  call         #j3loadWordPcPlus1
  mov          j3t0,  j3rc      ' j3t0 = default

  rdlong       j3rc,  j3pc
  add          j3rc,  #3
  call         #j3loadWord
  mov          j3t1,  j3rc      ' j3t1 = npairs

  call         #j3pop
  mov          j3t2,  j3rc      ' j3t2 = key
  mov          j3t3,  #5        ' j3t3 = index  

npairsLOOKUPSWITCH
  rdlong       j3rc,  j3pc      ' rc = pc
  add          j3rc,  j3t3      ' rc = pc + index
  mov          j3t5,  j3rc      ' j3t5 = pc + index
  add          j3t5,  #2        ' j3t5 = pc + index + 2
  call         #j3loadWord      ' match := jd.readJavaIntBE(jd.getJvmPC + index)
  mov          j3t4,  j3rc      ' j3t4 = match
              
  mov          j3rc,  j3t5
  call         #j3loadWord
  'mov          j3t5,  j3rc      ' j3t5 = offset

  cmp          j3t2,  j3t4 wz,wc
  if_ne jmp    #skipLOOKUPSWITCH' if key <> match, continue (next npairs lookup) 
  add          j3rc,  #1        ' offset + 1
  jmp          #j3addPCDone
  
skipLOOKUPSWITCH
  add          j3t3,  #4        
  djnz         j3t1,  #npairsLOOKUPSWITCH
  
  mov          j3rc,  j3t0
  add          j3rc,  #1        ' default + 1
  jmp          #j3addPCDone


'_____________________________________________________________________________
'
{{ doJem_NotUsed Meaning: Handle unused bytecode.
}}
'j3doJem_NotUsed
'  jmp          #jvm3done

'_____________________________________________________________________________
'
' j3push
' long  j3rc
'
j3push
  rdword       j3tp,  j3sp
  add          j3tp,  j3jem
  call         #j3swap16  
  wrword       j3rc,  j3tp
  add          j3tp,  #2
  sub          j3tp,  j3jem
  wrword       j3tp,  j3sp
  call         #j3swap16
j3push_ret      ret

'_____________________________________________________________________________
'
' j3pop
' long  j3rc
'
j3pop
  rdword       j3tp,  j3sp
  add          j3tp,  j3jem
  sub          j3tp,  #2
  rdword       j3rc,  j3tp
  call         #j3swap16  
  sub          j3tp,  j3jem
  wrword       j3tp,  j3sp
j3pop_ret       ret


'_____________________________________________________________________________
'
' j3swap16
' long  j3rc
j3swap16
  and          j3rc,j3Minus1  
  mov          j3arg3,j3rc
  and          j3rc,  #$ff
  shr          j3arg3,#8
  shl          j3rc,  #8
  or           j3rc, j3arg3
j3swap16_ret     ret

'_____________________________________________________________________________
'
' j3setWord16
' long  j3rc
j3setWord16
  and          j3arg1, j3Minus1  
  shl          j3arg1, #8
'  and          j3arg2, #$ff
  or           j3arg1, j3arg2
  mov          j3rc,   j3arg1
j3setWord16_ret      ret

'_____________________________________________________________________________
'
' j3loadBytePcPlus1
' long  j3rc
'
j3loadBytePcPlus1
  rdlong       j3rc,  j3pc
  add          j3rc,  j3jem
  add          j3rc,  #1   ' add j3pc+1
  rdbyte       j3rc,  j3rc   ' read byte at j3pc+1
j3loadBytePcPlus1_ret      ret

'_____________________________________________________________________________
'
' j3loadWordPcPlus1
' long  j3rc
'
j3loadWordPcPlus1
  rdlong       j3rc,  j3pc
  add          j3rc,  j3jem
  add          j3rc,  #1   ' add j3pc+1
  rdbyte       j3arg1,j3rc   ' read byte
  add          j3rc,  #1
  rdbyte       j3arg2,j3rc   ' read byte
  call         #j3setWord16
j3loadWordPcPlus1_ret      ret

'_____________________________________________________________________________
'
' j3loadByte
' long  j3rc
'
j3loadByte
  add          j3rc,  j3jem
  rdbyte       j3rc,  j3rc   ' read byte at j3pc+1
j3loadByte_ret   ret

'_____________________________________________________________________________
'
' j3loadWord
' long  j3rc
'
j3loadWord
  add          j3rc,  j3jem
  rdbyte       j3arg1,j3rc   ' read byte
  add          j3rc,  #1
  rdbyte       j3arg2,j3rc   ' read byte
  call         #j3setWord16
j3loadWord_ret   ret

'_____________________________________________________________________________
'
' j3saveByte
' long  j3arg1 = address
' long  j3rc = data
'
j3saveByte
  mov          j3tp,  j3arg1 ' get bytecode base
  add          j3tp,  j3jem
  wrbyte       j3rc,  j3tp ' write byte
j3saveByte_ret   ret

'_____________________________________________________________________________
'
' j3saveWord
' long  j3arg1 = address
' long  j3rc = data
'
j3saveWord
  mov          j3tp,  j3arg1 ' get bytecode base
  add          j3tp,  j3jem
  add          j3tp,  #1
  wrbyte       j3rc,  j3tp   ' write word
  shr          j3rc,  #8
  sub          j3tp,  #1
  wrbyte       j3rc,  j3tp   ' write word
j3saveWord_ret   ret

'_____________________________________________________________________________
'
' call  #j3pop2signed
' long  j3arg1
' long  j3arg2
j3pop2signed
  call         #j3pop
  call         #j3signExtend16
  mov          j3arg1,j3rc          ' w1
  call         #j3pop
  call         #j3signExtend16
  mov          j3arg2,j3rc          ' w2
j3pop2signed_ret ret

{
'_____________________________________________________________________________
'
' jpop
' long  j3rc
'
j3poparg12
  rdword       j3tp,  j3sp
  add          j3tp,  j3jem
  sub          j3tp,  #2
  rdword       j3rc,  j3tp
  call         #j3swap16  
  mov          j3arg1,j3rc
  sub          j3tp,  #2
  rdword       j3rc,j3tp
  call         #j3swap16  
  mov          j3arg2,j3rc
  sub          j3tp,  j3jem
  wrword       j3tp,  j3sp
j3pop2signed_ret ret
'j3poparg12_ret ret
}

'_____________________________________________________________________________
'
' call  #signExtend16
' long  j3rc
j3signExtend16
  test         j3rc,  j3MSB16 wz
  if_nz or     j3rc,  j3M1WDXT
j3signExtend16_ret   ret

'_____________________________________________________________________________
'
j3pushIncrPCdone
  call         #j3push
j3incrPCdone
  rdlong       j3rc,  j3pc
  add          j3rc,  #1
  wrlong       j3rc,  j3pc
  jmp          #jvm3done

'_____________________________________________________________________________
'
j3pushIncrPC2done
  call         #j3push
j3incrPC2
  rdlong       j3rc,  j3pc
  add          j3rc,  #2
  wrlong       j3rc,  j3pc
  jmp          #jvm3done

'_____________________________________________________________________________
'
j3pushIncrPC3done
  call         #j3push
j3incrPC3done
  rdlong       j3rc,  j3pc
  add          j3rc,  #3
  wrlong       j3rc,  j3pc
  jmp          #jvm3done

'_____________________________________________________________________________
'
j3addPCDone
  call         #j3signExtend16
  rdlong       j3tp, j3pc
  add          j3tp, j3rc
  wrlong       j3tp, j3pc
  jmp          #jvm3done

'_____________________________________________________________________________
'
' alloc
' @parm j3arg1  number of bytes
' @return j3rc  new pointer
'
{ ' save for unmanaged memory allocations
j3allocate
  rdlong        j3rc,  j3hp       ' get heap
  rdlong        j3tp,  j3sp       ' get stack
  cmp           j3rc,  j3tp wc    ' is there overlap?
  if_c  mov     j3rc,  #0         ' null pointer means out of memory
  if_nc add     j3arg1,#2         ' room for pointer
  if_nc sub     j3rc,  j3arg1     ' allocate number of bytes + pointer + next
  if_nc wrlong  j3rc,  j3hp       ' save data pointer
j3allocate_ret   ret
'}
'{
j3allocate
{
  rdlong      j3rc,  j3hp       ' get heap
  rdlong      j3tp,  j3sp       ' get stack
  sub         j3rc,  j3tp wc    ' is there overlap?
  if_c  mov   j3rc,  #0         ' null pointer means out of memory
  if_c  jmp   #j3allocate_ret   ' return out of memory
'}
  mov         j3rc, j3MALLOC    ' handler does alloc if MALLOC_BIT set
  or          j3rc, j3arg1      ' request j3arg1 bytes
  wrlong      j3rc, j3ctrp      ' write alloc request
  rdlong      j3rc, j3ctrp      ' wait for request complete
  cmps        j3rc, #0  wc      ' wait until D < S
  if_nc       jmp   #$-2        ' if D > S wait for request complete
  rdlong      j3rc, j3ap        ' get reference
j3allocate_ret   ret
'}

'_____________________________________________________________________________
'
' j3multiply
' @parm j3arg1        term 1
' @parm j3arg2        term 2
' @return j3rc        product
'
j3multiply
  call        #j3psign
  mov         j3rc,#0
j3muloop
  shr         j3arg1,#1   wc
  if_c  add   j3rc,j3arg2
  shl         j3arg2,#1
  tjnz        j3arg1,#j3muloop
j3multiply_ret  ret

'____________________________________________
' chip's divide
' quotient in j3arg1
' remainder in j3arg2
'
j3divide
  call        #j3psign
  mov         j3t1,     #0
  mov         j3t2,     #32
:div
  shr         j3arg1,   #1      wz,wc
  rcr         j3t1,     #1
  if_nz djnz  j3t2,     #:div
:div2
  cmpsub      j3arg2,   j3t1    wc
  rcl         j3arg1,   #1
  shr         j3t1,     #1
  djnz        j3t2,     #:div2
j3divide_ret   ret               

j3psign
  test        j3arg1,   j3MSB16 wc
  test        j3arg2,   j3MSB16 wz
  wrlong      j3zero,   j3cp                    'carry is used for storing result sign
  if_c_and_z   wrlong   j3one,   j3cp           'result should be negative
  if_nc_and_nz wrlong   j3one,   j3cp           'result should be negative
  abs         j3arg1,   j3arg1
  abs         j3arg2,   j3arg2
j3psign_ret   ret

j3signResult
  rdlong      j3rc,     j3cp wz
  if_nz       neg       j3arg1, j3arg1
  and         j3arg1,   j3MINUS1
  mov         j3rc,     j3arg1
'  wrlong      j3zero,   j3cp                   ' jvm doesn't care about carry for div,mod,mult
j3signResult_ret ret

'_____________________________________________________________________________
'return readJavaIntBE(stringIndex + (index<<1))
' rc = index
j3loadConst
  rdlong       j3tp,  j3strp    ' stringIndex
  mov          j3arg3,j3rc
  shl          j3arg3,#1
  add          j3tp,  j3arg3    ' + index << 1
  mov          j3rc,  j3tp
  call         #j3loadWord      ' j3rc = return word
j3loadConst_ret   ret

'_____________________________________________________________________________
'
' set exception
'
j3exception
  rdlong       j3rc, j3pc
  or           j3rc, j3MSB16       ' j3EXCPTN
  or           j3rc, j3t0
  wrlong       j3rc, j3cmdp        ' set exception command
  jmp          #jvm3done

'_____________________________________________________________________________
'
' support constants
'
j3MINUS1  long   $FFFF    ' 16 bit machine
j3MSB16   long   $8000
j3M1WDXT  long   $FFFF0000
j3x4000   long   $1000
j3MALLOC  long   MALLOC_BIT

'_____________________________________________________________________________
'
' call variables
'
j3arg1    long 0
j3arg2    long 0
j3arg3    long 0
j3rc      long 0

'_____________________________________________________________________________
'
' local variables
'
j3tp      long 0
j3t0      long 0
j3t1      long 0
j3t2      long 0
j3t3      long 0
j3t4      long 0
j3t5      long 0
j3one     long 1
j3zero    long 0

'_____________________________________________________________________________
'
' spin command interface
'
j3cmdp    long 0    ' shared jvm instruction pointer
j3ctrp    long 0    ' control pointer 0 if nothing to do
j3jemp    long 0    ' j3jem pointer

'_____________________________________________________________________________
'
' jvm  variables
'
j3pc      long 0    ' program counter pointer
j3bp      long 0    ' stack base pointer
j3sp      long 0    ' stack pointer
j3fp      long 0    ' frame pointer
j3mp      long 0    ' method pointer
j3ap      long 0    ' allocated heap pointer
j3hp      long 0    ' heap end pointer
j3ep      long 0    ' exception pointer
j3cp      long 0    ' carry pointer
j3sbp     long 0    ' static base pointer
j3strp    long 0    ' strings pointer
j3tap1    long 0    ' jump table pointer1
j3tap2    long 0    ' jump table pointer2
j3tap3    long 0    ' jump table pointer3   

j3jem     long 0    ' j3jem base

  fit   $1f0
'_____________________________________________________________________________
'
'}
  
dat
  jemcode file "jem.bin" 
  jemcode_end long 0
                           
dat
  progbuf2 byte 0 [JAVACODESIZE-(@progbuf2-@progbuf)]
  long  $55555555


'_____________________________________________________________________________
'
'